#pragma once

#include <windows.h>

#include "../Common/Util.h"
#include "../Common/StructDef.h"
#include "../Common/EpgTimerUtil.h"
#include "../Common/StringUtil.h"

#include "BonDriverUtil.h"
#include "PacketInit.h"
#include "TSOut.h"
#include "ChSetUtil.h"

class CBonCtrl
{
public:
	CBonCtrl(void);
	~CBonCtrl(void);

	//ݒ
	//ݒt@CۑBonDrivertH_w
	//F
	// settingFolderPath		[IN]ݒt@CۑtH_pX
	// bonDriverFolderPath		[IN]BonDrivertH_pX
	void SetSettingFolder(
		LPCWSTR settingFolderPath,
		LPCWSTR bonDriverFolderPath
		);

	void SetEMMMode(BOOL enable);

	void SetTsBuffMaxCount(DWORD tsBuffMaxCount, int writeBuffMaxCount);

	//BonDrivertH_BonDriver_*.dll
	//߂lF
	// G[R[h
	//F
	// bonList			[OUT]łBonDriverꗗimap̃L[ CfbNXlAmap̒l BonDrivert@Cj
	DWORD EnumBonDriver(
		map<int, wstring>* bonList
		);

	//BonDriver̃[h
	//BonDriver[hă`lȂǂ擾iCfbNXlŎwj
	//߂lF
	// G[R[h
	//F
	// index			[IN]EnumBonDriverŎ擾ꂽBonDriver̃CfbNXl
	DWORD OpenBonDriver(
		int index,
		int openWait = 200
		);

	//BonDriver[hă`lȂǂ擾it@CŎwj
	//߂lF
	// G[R[h
	//F
	// bonDriverFile	[IN]EnumBonDriverŎ擾ꂽBonDriver̃t@C
	DWORD OpenBonDriver(
		LPCWSTR bonDriverFile,
		int openWait = 200
		);

	//[hĂBonDriver̊J
	//߂lF
	// G[R[h
	DWORD CloseBonDriver();

	//[hBonDriver̃t@C擾i[hĂ邩̔j
	//߂lF
	// TRUEijFFALSEiOpenɎsĂj
	//F
	// bonDriverFile		[OUT]BonDriver̃t@C(NULL)
	BOOL GetOpenBonDriver(
		wstring* bonDriverFile
		);

	//[hBonDriveȑ擾
	//SpaceCḧꗗ擾
	//߂lF
	// G[R[h
	//F
	// spaceMap			[OUT] SpaceCḧꗗimap̃L[ Spacej
	DWORD GetOriginalChList(
		map<DWORD, BON_SPACE_INFO>* spaceMap
	);

	//BonDriver̃`[i[擾
	//߂lF
	// `[i[
	wstring GetTunerName();

	//`lύX
	//߂lF
	// G[R[h
	//F
	// space			[IN]ύX`lSpace
	// ch				[IN]ύX`l̕Ch
	DWORD SetCh(
		DWORD space,
		DWORD ch
		);

	//`lύX
	//߂lF
	// G[R[h
	//F
	// space			[IN]ύX`lSpace
	// ch				[IN]ύX`l̕Ch
	// SID			[IN]ύX`l̕service_id
	DWORD SetCh(
		DWORD space,
		DWORD ch,
		WORD SID
		);

	//`lύX
	//߂lF
	// G[R[h
	//F
	// ONID			[IN]ύX`lorignal_network_id
	// TSID			[IN]ύX`l̕transport_stream_id
	// SID			[IN]ύX`l̕service_id
	DWORD SetCh(
		WORD ONID,
		WORD TSID,
		WORD SID
		);

	BOOL GetCh(
		DWORD* space,
		DWORD* ch
		);

	//`lύXǂ
	//߂lF
	// TRUEiύXjAFALSEij
	BOOL IsChChanging(BOOL* chChgErr);

	//݂̃Xg[ID擾
	//߂lF
	// TRUEijAFALSEisj
	//F
	// ONID		[OUT]originalNetworkID
	// TSID		[OUT]transportStreamID
	BOOL GetStreamID(
		WORD* ONID,
		WORD* TSID
		);

	//VOix̎擾
	//߂lF
	// VOix
	float GetSignalLevel();

	//EPGf[^̒~ϏԂZbg
	void ClearSectionStatus();

	//EPGf[^̒~ϏԂ擾
	//߂lF
	// Xe[^X
	//F
	// l_eitFlag		[IN]L-EIT̃Xe[^X擾
	EPG_SECTION_STATUS GetSectionStatus(
		BOOL l_eitFlag
		);

	//Xg[̃T[rXꗗ擾
	//߂lF
	// G[R[h
	//F
	// serviceList				[OUT]T[rX̃Xg
	DWORD GetServiceListActual(
		vector<TS_SERVICE_INFO>* serviceList
		);

	//T[rXꗗ擾
	//߂lF
	// G[R[h
	//F
	// serviceList				[OUT]T[rX̃Xg
	DWORD GetServiceList(
		vector<CH_DATA4>* serviceList
		);

	//TSXg[pRg[쐬
	//߂lF
	// G[R[h
	//F
	// id			[OUT]䎯ID
	BOOL CreateServiceCtrl(
		DWORD* id
		);

	//TSXg[pRg[쐬
	//߂lF
	// G[R[h
	//F
	// id			[IN]䎯ID
	BOOL DeleteServiceCtrl(
		DWORD id
		);

	//Ώۂ̃T[rXݒ肷
	//߂lF
	// TRUEijAFALSEis
	//F
	// id			[IN]䎯ID
	// serviceID	[IN]ΏۃT[rXIDA0xFFFFőST[rXΏ
	BOOL SetServiceID(
		DWORD id,
		WORD serviceID
		);

	BOOL GetServiceID(
		DWORD id,
		WORD* serviceID
		);

	//UDPőMs
	//߂lF
	// TRUEijAFALSEisj
	//F
	// id			[IN]䎯ID
	// sendList		[IN/OUT]M惊XgBNULLŒ~BPort͎ۂɑMɎgpPortԂB
	BOOL SendUdp(
		DWORD id,
		vector<NW_SEND_INFO>* sendList
		);

	//TCPőMs
	//߂lF
	// TRUEijAFALSEisj
	//F
	// id			[IN]䎯ID
	// sendList		[IN/OUT]M惊XgBNULLŒ~BPort͎ۂɑMɎgpPortԂB
	BOOL SendTcp(
		DWORD id,
		vector<NW_SEND_INFO>* sendList
		);

	//t@CۑJn
	//߂lF
	// TRUEijAFALSEisj
	//F
	// id					[IN]䎯ID
	// fileName				[IN]ۑt@CpX
	// overWriteFlag		[IN]t@Cݎɏ㏑邩ǂiTRUEFAFALSEFȂj
	// pittariFlag			[IN]҂胂[hiTRUEFAFALSEFȂj
	// pittariONID			[IN]҂胂[hŘ^悷ONID
	// pittariTSID			[IN]҂胂[hŘ^悷TSID
	// pittariSID			[IN]҂胂[hŘ^悷SID
	// pittariEventID		[IN]҂胂[hŘ^悷CxgID
	// createSize			[IN]t@C쐬ɃfBXNɗ\񂷂e
	// saveFolder			[IN]gptH_ꗗ
	// saveFolderSub		[IN]HDD̋󂫂ȂȂꍇɈꎞIɎgptH_
	BOOL StartSave(
		DWORD id,
		wstring fileName,
		BOOL overWriteFlag,
		BOOL pittariFlag,
		WORD pittariONID,
		WORD pittariTSID,
		WORD pittariSID,
		WORD pittariEventID,
		ULONGLONG createSize,
		vector<REC_FILE_SET_INFO>* saveFolder,
		vector<wstring>* saveFolderSub
	);

	//t@CۑI
	//߂lF
	// TRUEijAFALSEisj
	//F
	// id			[IN]䎯ID
	BOOL EndSave(
		DWORD id
		);

	//XNu̓ݒ
	//߂lF
	// TRUEijAFALSEisj
	//F
	// id			[IN]䎯ID
	// enable		[IN] TRUEijAFALSEiȂj
	BOOL SetScramble(
		DWORD id,
		BOOL enable
		);

	//ƃf[^܂߂邩ǂ
	//F
	// id					[IN]䎯ID
	// enableCaption		[IN] TRUEi܂߂jAFALSEi܂߂Ȃj
	// enableData			[IN]f[^ TRUEi܂߂jAFALSEi܂߂Ȃj
	void SetServiceMode(
		DWORD id,
		BOOL enableCaption,
		BOOL enableData
		);

	//G[JEgNA
	//F
	// id					[IN]䎯ID
	void ClearErrCount(
		DWORD id
		);

	//hbvƃXNũJEg擾
	//F
	// id					[IN]䎯ID
	// drop					[OUT]hbv
	// scramble				[OUT]XNu
	void GetErrCount(
		DWORD id,
		ULONGLONG* drop,
		ULONGLONG* scramble
		);

	//^撆̃t@C̃t@CpX擾
	//F
	// id					[IN]䎯ID
	// filePath				[OUT]ۑt@C
	// subRecFlag			[OUT]Tu^悪ǂ
	void GetSaveFilePath(
		DWORD id,
		wstring* filePath,
		BOOL* subRecFlag
		);

	//hbvƃXNũJEgۑ
	//F
	// id					[IN]䎯ID
	// filePath				[IN]ۑt@C
	void SaveErrCount(
		DWORD id,
		wstring filePath
		);

	//^撆̃t@C̏o̓TCY擾
	//F
	// id					[IN]䎯ID
	// writeSize			[OUT]ۑt@C
	void GetRecWriteSize(
		DWORD id,
		__int64* writeSize
		);

	//wT[rX̌orEPG擾
	//߂lF
	// G[R[h
	//F
	// originalNetworkID		[IN]擾ΏۂoriginalNetworkID
	// transportStreamID		[IN]擾ΏۂtransportStreamID
	// serviceID				[IN]擾ΏۂServiceID
	// nextFlag					[IN]TRUEi̔ԑgjAFALSEi݂̔ԑgj
	// epgInfo					[OUT]EPGiDLLŎIdeleteBɎ擾s܂ŗLj
	DWORD GetEpgInfo(
		WORD originalNetworkID,
		WORD transportStreamID,
		WORD serviceID,
		BOOL nextFlag,
		EPGDB_EVENT_INFO* epgInfo
		);

	//wCxgEPG擾
	//߂lF
	// G[R[h
	//F
	// originalNetworkID		[IN]擾ΏۂoriginalNetworkID
	// transportStreamID		[IN]擾ΏۂtransportStreamID
	// serviceID				[IN]擾ΏۂServiceID
	// eventID					[IN]擾ΏۂEventID
	// pfOnlyFlag				[IN]p/f̂݌邩ǂ
	// epgInfo					[OUT]EPGiDLLŎIdeleteBɎ擾s܂ŗLj
	DWORD SearchEpgInfo(
		WORD originalNetworkID,
		WORD transportStreamID,
		WORD serviceID,
		WORD eventID,
		BYTE pfOnlyFlag,
		EPGDB_EVENT_INFO* epgInfo
		);
	
	//PCvƂXg[ԂƂ̍擾
	//߂lF
	// ̕b
	int GetTimeDelay(
		);

	//^撆ǂ擾
	// TRUEi^撆jAFALSEi^悵ĂȂj
	BOOL IsRec();

	//`lXLJn
	//߂lF
	// G[R[h
	DWORD StartChScan();

	//`lXLLZ
	//߂lF
	// G[R[h
	DWORD StopChScan();

	//`lXL̏Ԃ擾
	//߂lF
	// G[R[h
	//F
	// space		[OUT]XL̕CHspace
	// ch			[OUT]XL̕CHch
	// chName		[OUT]XL̕CH̖O
	// chkNum		[OUT]`FbNς݂̐
	// totalNum		[OUT]`FbNΏۂ̑
	DWORD GetChScanStatus(
		DWORD* space,
		DWORD* ch,
		wstring* chName,
		DWORD* chkNum,
		DWORD* totalNum
		);

	//EPG擾Ώۂ̃T[rXꗗ擾
	//߂lF
	// G[R[h
	//F
	// chList		[OUT]EPG擾`lꗗ
	DWORD GetEpgCapService(
		vector<EPGCAP_SERVICE_INFO>* chList
		);


	//EPG擾Jn
	//߂lF
	// G[R[h
	//F
	// chList		[IN]EPG擾`lꗗ
	// BSBasic		[IN]BSłP`l{̂ݎ擾邩ǂ
	// CS1Basic		[IN]CS1łP`l{̂ݎ擾邩ǂ
	// CS2Basic		[IN]CS2łP`l{̂ݎ擾邩ǂ
	DWORD StartEpgCap(
		vector<EPGCAP_SERVICE_INFO>* chList,
		BOOL BSBasic,
		BOOL CS1Basic,
		BOOL CS2Basic
		);

	//EPG擾~
	//߂lF
	// G[R[h
	DWORD StopEpgCap(
		);

	//EPG擾̃Xe[^X擾
	//߂lF
	// G[R[h
	//F
	// info			[OUT]擾̃T[rX
	DWORD GetEpgCapStatus(
		EPGCAP_SERVICE_INFO* info
		);

	//obNOEhłEPG擾ݒ
	//F
	// enableLive	[IN]Ɏ擾
	// enableRec	[IN]^撆Ɏ擾
	// enableRec	[IN]EPG擾`lꗗ
	// BSBasic		[IN]BSłP`l{̂ݎ擾邩ǂ
	// CS1Basic		[IN]CS1łP`l{̂ݎ擾邩ǂ
	// CS2Basic		[IN]CS2łP`l{̂ݎ擾邩ǂ
	// backStartWaitSec	[IN]Ch؂ւA^JnAobNOEhłEPG擾Jn܂ł̕b
	void SetBackGroundEpgCap(
		BOOL enableLive,
		BOOL enableRec,
		BOOL BSBasic,
		BOOL CS1Basic,
		BOOL CS2Basic,
		DWORD backStartWaitSec
		);

	BOOL GetViewStatusInfo(
		DWORD id,
		float* signal,
		DWORD* space,
		DWORD* ch,
		ULONGLONG* drop,
		ULONGLONG* scramble
		);

protected:
	CBonDriverUtil bonUtil;
	CPacketInit packetInit;
	CTSOut tsOut;
	CChSetUtil chUtil;

	HANDLE lockEvent;

	HANDLE buffLockEvent;
	vector<TS_DATA*> TSBuff;

	HANDLE recvThread;
	HANDLE recvStopEvent;
	HANDLE analyzeThread;
	HANDLE analyzeStopEvent;

	//`lXLp
	HANDLE chScanThread;
	HANDLE chScanStopEvent;
	DWORD chSt_space;
	DWORD chSt_ch;
	wstring chSt_chName;
	DWORD chSt_chkNum;
	DWORD chSt_totalNum;
	DWORD chSt_err;
	typedef struct _CHK_CH_INFO{
		DWORD space;
		DWORD ch;
		wstring spaceName;
		wstring chName;
	}CHK_CH_INFO;

	//EPG擾p
	HANDLE epgCapThread;
	HANDLE epgCapStopEvent;
	vector<EPGCAP_SERVICE_INFO> epgCapChList;
	BOOL BSBasic;
	BOOL CS1Basic;
	BOOL CS2Basic;
	EPGCAP_SERVICE_INFO epgSt_ch;
	DWORD epgSt_err;

	HANDLE epgCapBackThread;
	HANDLE epgCapBackStopEvent;
	BOOL enableLiveEpgCap;
	BOOL enableRecEpgCap;
	WORD lastSID;

	DWORD epgCapBackStartWaitSec;
	DWORD tsBuffMaxCount;
	int writeBuffMaxCount;
protected:
	//PublicAPIrp
	BOOL Lock(LPCWSTR log = NULL, DWORD timeOut = 15*1000);
	void UnLock(LPCWSTR log = NULL);

	//BonDriver[h̏
	//߂lF
	// G[R[h
	DWORD _OpenBonDriver();

	//[hĂBonDriver̊J{
	//߂lF
	// G[R[h
	DWORD _CloseBonDriver();

	DWORD _SetCh(
		DWORD space,
		DWORD ch,
		BOOL chScan = FALSE
		);

	void GetEpgDataFilePath(WORD ONID, WORD TSID, wstring& epgDataFilePath);

	static UINT WINAPI RecvThread(LPVOID param);
	static UINT WINAPI AnalyzeThread(LPVOID param);

	static UINT WINAPI ChScanThread(LPVOID param);
	static UINT WINAPI EpgCapThread(LPVOID param);

	void StartBackgroundEpgCap();
	void StopBackgroundEpgCap();
	static UINT WINAPI EpgCapBackThread(LPVOID param);
};

