#include "StdAfx.h"
#include "OneServiceUtil.h"


COneServiceUtil::COneServiceUtil(void)
{
	this->id = 0;
	this->SID = 0xFFFF;

	this->sendUdp = NULL;
	this->sendTcp = NULL;
	this->writeFile = NULL;

	this->buff = 0;
	this->buffSize = 0;
	this->buffWriteSize = 0;

	this->pmtPID = 0xFFFF;

	this->enableScramble = TRUE;
	this->epgUtil = NULL;

	this->pittariStart = FALSE;
	this->pittariEndChk = FALSE;
	this->maxBuffCount = -1;
}


COneServiceUtil::~COneServiceUtil(void)
{
	SAFE_DELETE(this->sendUdp);
	SAFE_DELETE(this->sendTcp);
	SAFE_DELETE(this->writeFile);

	SAFE_DELETE_ARRAY(this->buff);
}

void COneServiceUtil::SetEpgUtil(
	CEpgDataCap3Util* epgUtil
	)
{
	this->epgUtil = epgUtil;
}


//ID̐ݒ
//F
// id			[IN]ID
void COneServiceUtil::SetID(
	DWORD id
	)
{
	this->id = id;
}

//ID̎擾
//߂lF
// ID
DWORD COneServiceUtil::GetID()
{
	return this->id;
}

//ΏServiceIDݒ
//F
// SID			[IN]ServiceID
void COneServiceUtil::SetSID(
	WORD SID
)
{
	if( this->SID != SID ){
		this->pmtPID = 0xFFFF;
		this->emmPIDMap.clear();

		this->dropCount.Clear();
	}
	this->SID = SID;
}

//ݒ肳Ă鏈ΏۂServiceID擾
//߂lF
// ServiceID
WORD COneServiceUtil::GetSID()
{
	return this->SID;
}

//UDPőMs
//߂lF
// TRUEijAFALSEisj
//F
// id			[IN]䎯ID
// sendList		[IN/OUT]M惊XgBNULLŒ~BPort͎ۂɑMɎgpPortԂB
BOOL COneServiceUtil::SendUdp(
	vector<NW_SEND_INFO>* sendList
	)
{
	if( this->sendUdp != NULL ){
		this->sendUdp->CloseUpload();
	}

	if(udpPortMutex.size() != 0){
		for( int i=0; i<(int)udpPortMutex.size(); i++ ){
			::ReleaseMutex(udpPortMutex[i]);
			::CloseHandle(udpPortMutex[i]);
		}
		udpPortMutex.clear();
	}

	if( sendList != NULL ){
		if( this->sendUdp == NULL ){
			this->sendUdp = new CSendUDP;
		}
		for( size_t i=0; i<sendList->size(); i++ ){
			wstring key = L"";

			while(1){
				Format(key, L"%s%d_%d", MUTEX_UDP_PORT_NAME, (*sendList)[i].ip, (*sendList)[i].port );
				HANDLE mutex = ::OpenMutex(MUTEX_ALL_ACCESS, FALSE, key.c_str());
		
				if(mutex){
					::CloseHandle(mutex);
					(*sendList)[i].port++;
				}else{
					break;
				}
			}

			HANDLE portMutex = _CreateMutex( TRUE, key.c_str());
			_OutputDebugString(L"%s\r\n", key.c_str());
			udpPortMutex.push_back(portMutex);
		}

		this->sendUdp->StartUpload(sendList);
	}else{
		SAFE_DELETE(this->sendUdp);
	}

	return TRUE;
}

//TCPőMs
//߂lF
// TRUEijAFALSEisj
//F
// id			[IN]䎯ID
// sendList		[IN/OUT]M惊XgBNULLŒ~BPort͎ۂɑMɎgpPortԂB
BOOL COneServiceUtil::SendTcp(
	vector<NW_SEND_INFO>* sendList
	)
{
	if( this->sendTcp != NULL ){
		this->sendTcp->CloseUpload();
	}

	if(tcpPortMutex.size() != 0){
		for( int i=0; i<(int)tcpPortMutex.size(); i++ ){
			::ReleaseMutex(tcpPortMutex[i]);
			::CloseHandle(tcpPortMutex[i]);
		}
		tcpPortMutex.clear();
	}

	if( sendList != NULL ){
		if( this->sendTcp == NULL ){
			this->sendTcp = new CSendTCP;
		}
		for( size_t i=0; i<sendList->size(); i++ ){
			wstring key = L"";

			while(1){
				Format(key, L"%s%d_%d", MUTEX_TCP_PORT_NAME, (*sendList)[i].ip, (*sendList)[i].port );
				HANDLE mutex = ::OpenMutex(MUTEX_ALL_ACCESS, FALSE, key.c_str());
		
				if(mutex){
					::CloseHandle(mutex);
					(*sendList)[i].port++;
				}else{
					break;
				}
			}

			HANDLE portMutex = _CreateMutex( TRUE, key.c_str());
			_OutputDebugString(L"%s\r\n", key.c_str());
			tcpPortMutex.push_back(portMutex);
		}

		this->sendTcp->StartUpload(sendList);
	}else{
		SAFE_DELETE(this->sendTcp);
	}

	return TRUE;
}

//o͗pTSf[^𑗂
//߂lF
// TRUEijAFALSEisj
//F
// data		[IN]TSf[^
// size		[IN]datãTCY
BOOL COneServiceUtil::AddTSBuff(
	BYTE* data,
	DWORD size
	)
{
	BOOL ret = TRUE;
	if( this->SID == 0xFFFF || this->sendTcp != NULL || this->sendUdp != NULL){
		//ST[rX
		ret = WriteData(data, size);
		for( DWORD i=0; i<size; i+=188 ){
			CTSPacketUtil packet;
			if( packet.Set188TS(data + i, 188) == TRUE ){
				if( packet.PID == this->pmtPID ){
					DWORD err = createPmt.AddData(&packet);
				}
			}
		}
	}else{
		if( size > this->buffSize ){
			SAFE_DELETE_ARRAY(this->buff);
			this->buff = new BYTE[size*2];
			this->buffSize = size*2;
		}
		this->buffWriteSize = 0;

		for( DWORD i=0; i<size; i+=188 ){
			CTSPacketUtil packet;
			if( packet.Set188TS(data + i, 188) == TRUE ){
				if( packet.PID == 0x0000 ){
					//PAT
					BYTE* patBuff = NULL;
					DWORD patBuffSize = 0;
					if( createPat.GetPacket(&patBuff, &patBuffSize) == TRUE ){
						memcpy(this->buff + this->buffWriteSize, patBuff, patBuffSize);
						this->buffWriteSize+=patBuffSize;
					}
				}else if( packet.PID == this->pmtPID ){
					//PMT
					DWORD err = createPmt.AddData(&packet);
					if( err == NO_ERR || err == ERR_NO_CHAGE ){
						BYTE* pmtBuff = NULL;
						DWORD pmtBuffSize = 0;
						if( createPmt.GetPacket(&pmtBuff, &pmtBuffSize) == TRUE ){
							memcpy(this->buff + this->buffWriteSize, pmtBuff, pmtBuffSize);
							this->buffWriteSize+=pmtBuffSize;
						}else{
							_OutputDebugString(L"createPmt.GetPacket Err");
							//̂܂
							memcpy(this->buff + this->buffWriteSize, data+i, 188);
							this->buffWriteSize+=188;
						}
					}else if( err == FALSE ){
						_OutputDebugString(L"createPmt.AddData Err");
						//̂܂
						memcpy(this->buff + this->buffWriteSize, data+i, 188);
						this->buffWriteSize+=188;
					}
				}else{
					//̑
					if( packet.PID < 0x0030 ){
						//̂܂
						memcpy(this->buff + this->buffWriteSize, data+i, 188);
						this->buffWriteSize+=188;
					}else{
						if( createPmt.IsNeedPID(packet.PID) == TRUE ){
							//PMTŒ`Ă
							memcpy(this->buff + this->buffWriteSize, data+i, 188);
							this->buffWriteSize+=188;
						}else{
							//EMMȂKv
							map<WORD,WORD>::iterator itr;
							itr = this->emmPIDMap.find(packet.PID);
							if( itr != this->emmPIDMap.end() ){
								memcpy(this->buff + this->buffWriteSize, data+i, 188);
								this->buffWriteSize+=188;
							}
						}
					}
				}
			}
		}

		WriteData(this->buff, this->buffWriteSize);
	}

	if( this->pittariStart == TRUE ){
		if( this->lastPMTVer == 0xFFFF ){
			this->lastPMTVer = createPmt.GetVersion();
		}else if(this->lastPMTVer != createPmt.GetVersion()){
			//҂Jn
			StratPittariRec();
			this->lastPMTVer = createPmt.GetVersion();
		}
		if( this->epgUtil != NULL ){
			EPG_EVENT_INFO* epgInfo;
			if( this->epgUtil->GetEpgInfo( this->pittariONID, this->pittariTSID, this->pittariSID, FALSE, &epgInfo ) == NO_ERR ){
				if( epgInfo->event_id == this->pittariEventID ){
					//҂Jn
					StratPittariRec();
					this->pittariStart = FALSE;
					this->pittariEndChk = TRUE;
				}
			}
		}
	}
	if( this->pittariEndChk == TRUE ){
		if( this->epgUtil != NULL ){
			EPG_EVENT_INFO* epgInfo;
			if( this->epgUtil->GetEpgInfo( this->pittariONID, this->pittariTSID, this->pittariSID, FALSE, &epgInfo ) == NO_ERR ){
				if( epgInfo->event_id != this->pittariEventID ){
					//҂I
					StopPittariRec();
					this->pittariEndChk = FALSE;
				}
			}
		}
	}

	return ret;
}

BOOL COneServiceUtil::WriteData(BYTE* data, DWORD size)
{
	if( this->sendUdp != NULL ){
		this->sendUdp->SendData(data, size);
	}
	if( this->sendTcp != NULL ){
		this->sendTcp->SendData(data, size);
	}
	if( this->writeFile != NULL ){
		this->writeFile->AddTSBuff(data, size);
	}

	dropCount.AddData(data, size);

	return TRUE;
}

void COneServiceUtil::SetPmtPID(
	WORD TSID,
	WORD pmtPID
	)
{
	if( this->pmtPID != pmtPID && this->SID != 0xFFFF){
		_OutputDebugString(L"COneServiceUtil::SetPmtPID 0x%04x => 0x%04x", this->pmtPID, pmtPID);
		map<WORD, CCreatePATPacket::PROGRAM_PID_INFO> PIDMap;

		CCreatePATPacket::PROGRAM_PID_INFO item;
		item.PMTPID = pmtPID;
		item.SID = this->SID;
		PIDMap.insert(pair<WORD, CCreatePATPacket::PROGRAM_PID_INFO>(item.PMTPID,item));
		
		item.PMTPID = 0x0010;
		item.SID = 0x00;
		PIDMap.insert(pair<WORD, CCreatePATPacket::PROGRAM_PID_INFO>(item.PMTPID,item));
		
		createPat.SetParam(TSID, &PIDMap);

		this->pmtPID = pmtPID;
	}
}

void COneServiceUtil::SetEmmPID(
	map<WORD,WORD>* PIDMap
	)
{
	this->emmPIDMap = *PIDMap;
}

//t@CۑJn
//߂lF
// TRUEijAFALSEisj
//F
// fileName				[IN]ۑt@CpX
// overWriteFlag		[IN]t@Cݎɏ㏑邩ǂiTRUEFAFALSEFȂj
// pittariFlag			[IN]҂胂[hiTRUEFAFALSEFȂj
// pittariONID			[IN]҂胂[hŘ^悷ONID
// pittariTSID			[IN]҂胂[hŘ^悷TSID
// pittariSID			[IN]҂胂[hŘ^悷SID
// pittariEventID		[IN]҂胂[hŘ^悷CxgID
// createSize			[IN]t@C쐬ɃfBXNɗ\񂷂e
// saveFolder			[IN]gptH_ꗗ
// saveFolderSub		[IN]HDD̋󂫂ȂȂꍇɈꎞIɎgptH_
BOOL COneServiceUtil::StartSave(
	wstring fileName,
	BOOL overWriteFlag,
	BOOL pittariFlag,
	WORD pittariONID,
	WORD pittariTSID,
	WORD pittariSID,
	WORD pittariEventID,
	ULONGLONG createSize,
	vector<REC_FILE_SET_INFO>* saveFolder,
	vector<wstring>* saveFolderSub,
	int maxBuffCount
)
{
	this->maxBuffCount = maxBuffCount;
	if( pittariFlag == FALSE ){
		if( this->writeFile == NULL ){
			OutputDebugString(L"*:StartSave");
			this->writeFile = new CWriteTSFile;
			return this->writeFile->StartSave(fileName, overWriteFlag, createSize, saveFolder, saveFolderSub, this->maxBuffCount);
		}
	}else{
		if( this->writeFile == NULL ){
			OutputDebugString(L"*:StartSave pittariFlag");
			this->pittariRecFilePath = L"";
			this->fileName = fileName;
			this->overWriteFlag = overWriteFlag;
			this->createSize = createSize;
			this->saveFolder = *saveFolder;
			this->saveFolderSub = *saveFolderSub;
			this->pittariONID = pittariONID;
			this->pittariTSID = pittariTSID;
			this->pittariSID = pittariSID;
			this->pittariEventID = pittariEventID;

			this->lastPMTVer = 0xFFFF;

			this->pittariStart = TRUE;
			this->pittariEndChk = FALSE;

			return TRUE;
		}
	}

	return FALSE;
}

void COneServiceUtil::StratPittariRec()
{
	if( this->writeFile == NULL ){
		OutputDebugString(L"*:StratPittariRec");
		this->writeFile = new CWriteTSFile;
		this->writeFile->StartSave(this->fileName, this->overWriteFlag, this->createSize, &this->saveFolder, &this->saveFolderSub, this->maxBuffCount);
	}
}

void COneServiceUtil::StopPittariRec()
{
	if( this->writeFile == NULL ){
		return ;
	}
	OutputDebugString(L"*:StopPittariRec");
	BOOL subRec;
	this->writeFile->GetSaveFilePath(&this->pittariRecFilePath, &subRec);
	BOOL ret = this->writeFile->EndSave();
}

//t@CۑI
//߂lF
// TRUEijAFALSEisj
BOOL COneServiceUtil::EndSave()
{
	if( this->writeFile == NULL ){
		return FALSE;
	}
	BOOL ret = this->writeFile->EndSave();
	SAFE_DELETE(this->writeFile);
	OutputDebugString(L"*:EndSave");
	return ret;
}

//^撆ǂ
//߂lF
// TRUEi^撆jAFALSEiĂȂj
BOOL COneServiceUtil::IsRec()
{
	if( this->writeFile == NULL ){
		if( this->pittariStart == TRUE || this->pittariEndChk == TRUE ){
			return TRUE;
		}
		return FALSE;
	}else{
		return TRUE;
	}
}

//XNu̓ݒ
//߂lF
// TRUEijAFALSEisj
//F
// enable		[IN] TRUEijAFALSEiȂj
void COneServiceUtil::SetScramble(
	BOOL enable
	)
{
	this->enableScramble = enable;
}

//XNusǂ
//߂lF
// TRUEijAFALSEiȂj
BOOL COneServiceUtil::GetScramble(
	)
{
	return this->enableScramble;
}

//ƃf[^܂߂邩ǂ
//F
// enableCaption		[IN] TRUEi܂߂jAFALSEi܂߂Ȃj
// enableData			[IN]f[^ TRUEi܂߂jAFALSEi܂߂Ȃj
void COneServiceUtil::SetServiceMode(
	BOOL enableCaption,
	BOOL enableData
	)
{
	createPmt.SetCreateMode(enableCaption, enableData);
}

//G[JEgNA
void COneServiceUtil::ClearErrCount()
{
	this->dropCount.Clear();
}

//hbvƃXNũJEg擾
//F
// drop				[OUT]hbv
// scramble			[OUT]XNu
void COneServiceUtil::GetErrCount(ULONGLONG* drop, ULONGLONG* scramble)
{
	this->dropCount.GetCount(drop, scramble);
}

//^撆̃t@C̃t@CpX擾
//F
// filePath			[OUT]ۑt@C
// subRecFlag		[OUT]Tu^悪ǂ
void COneServiceUtil::GetSaveFilePath(
	wstring* filePath,
	BOOL* subRecFlag
	)
{
	if( this->writeFile != NULL ){
		this->writeFile->GetSaveFilePath(filePath, subRecFlag);
		if( filePath->size() == 0 ){
			*filePath = this->pittariRecFilePath;
		}
	}
}

//hbvƃXNũJEgۑ
//F
// filePath			[IN]ۑt@C
void COneServiceUtil::SaveErrCount(
	wstring filePath
	)
{
	this->dropCount.SaveLog(filePath);
}


void COneServiceUtil::SetSignalLevel(
	float signalLv
	)
{
	this->dropCount.SetSignal(signalLv);
}

//^撆̃t@C̏o̓TCY擾
//F
// writeSize			[OUT]ۑt@C
void COneServiceUtil::GetRecWriteSize(
	__int64* writeSize
	)
{
	if( this->writeFile != NULL ){
		this->writeFile->GetRecWriteSize(writeSize);
	}
}

void COneServiceUtil::SetBonDriver(
	wstring bonDriver
	)
{
	this->dropCount.SetBonDriver(bonDriver);
}

void COneServiceUtil::SetPIDName(
	map<WORD, string>* pidName
	)
{
	this->dropCount.SetPIDName(pidName);
}
