#pragma once

#include "../Common/Util.h"
#include "../Common/ErrDef.h"
#include "../Common/TSPacketUtil.h"
#include "../Common/StringUtil.h"
#include "../Common/EpgDataCap3Util.h"

#include "BonCtrlDef.h"
#include "SendUDP.h"
#include "SendTCP.h"
#include "WriteTSFile.h"
#include "PMTUtil.h"
#include "CATUtil.h"
#include "CreatePMTPacket.h"
#include "CreatePATPacket.h"
#include "DropCount.h"

class COneServiceUtil
{
public:
	COneServiceUtil(void);
	~COneServiceUtil(void);

	void SetEpgUtil(
		CEpgDataCap3Util* epgUtil
		);

	//ID̐ݒ
	//F
	// id			[IN]ID
	void SetID(
		DWORD id
		);

	//ID̎擾
	//߂lF
	// ID
	DWORD GetID();

	//ΏServiceIDݒ
	//F
	// SID			[IN]ServiceIDB0xFFFFőST[rXΏہB
	void SetSID(
		WORD SID
	);

	//ݒ肳Ă鏈ΏۂServiceID擾
	//߂lF
	// ServiceID
	WORD GetSID();

	//UDPőMs
	//߂lF
	// TRUEijAFALSEisj
	//F
	// sendList		[IN/OUT]M惊XgBNULLŒ~BPort͎ۂɑMɎgpPortԂB
	BOOL SendUdp(
		vector<NW_SEND_INFO>* sendList
		);

	//TCPőMs
	//߂lF
	// TRUEijAFALSEisj
	//F
	// sendList		[IN/OUT]M惊XgBNULLŒ~BPort͎ۂɑMɎgpPortԂB
	BOOL SendTcp(
		vector<NW_SEND_INFO>* sendList
		);

	//o͗pTSf[^𑗂
	//߂lF
	// TRUEijAFALSEisj
	//F
	// data		[IN]TSf[^
	// size		[IN]datãTCY
	BOOL AddTSBuff(
		BYTE* data,
		DWORD size
		);

	void SetPmtPID(
		WORD TSID,
		WORD pmtPID
		);

	void SetEmmPID(
		map<WORD,WORD>* PIDMap
		);

	//t@CۑJn
	//߂lF
	// TRUEijAFALSEisj
	//F
	// fileName				[IN]ۑt@CpX
	// overWriteFlag		[IN]t@Cݎɏ㏑邩ǂiTRUEFAFALSEFȂj
	// pittariFlag			[IN]҂胂[hiTRUEFAFALSEFȂj
	// pittariONID			[IN]҂胂[hŘ^悷ONID
	// pittariTSID			[IN]҂胂[hŘ^悷TSID
	// pittariSID			[IN]҂胂[hŘ^悷SID
	// pittariEventID		[IN]҂胂[hŘ^悷CxgID
	// createSize			[IN]t@C쐬ɃfBXNɗ\񂷂e
	// saveFolder			[IN]gptH_ꗗ
	// saveFolderSub		[IN]HDD̋󂫂ȂȂꍇɈꎞIɎgptH_
	BOOL StartSave(
		wstring fileName,
		BOOL overWriteFlag,
		BOOL pittariFlag,
		WORD pittariONID,
		WORD pittariTSID,
		WORD pittariSID,
		WORD pittariEventID,
		ULONGLONG createSize,
		vector<REC_FILE_SET_INFO>* saveFolder,
		vector<wstring>* saveFolderSub,
		int maxBuffCount
	);

	//t@CۑI
	//߂lF
	// TRUEijAFALSEisj
	BOOL EndSave();

	//^撆ǂ
	//߂lF
	// TRUEi^撆jAFALSEiĂȂj
	BOOL IsRec();

	//XNu̓ݒ
	//߂lF
	// TRUEijAFALSEisj
	//F
	// enable		[IN] TRUEijAFALSEiȂj
	void SetScramble(
		BOOL enable
		);

	//XNusǂ
	//߂lF
	// TRUEijAFALSEiȂj
	BOOL GetScramble(
		);

	//ƃf[^܂߂邩ǂ
	//F
	// enableCaption		[IN] TRUEi܂߂jAFALSEi܂߂Ȃj
	// enableData			[IN]f[^ TRUEi܂߂jAFALSEi܂߂Ȃj
	void SetServiceMode(
		BOOL enableCaption,
		BOOL enableData
		);

	//G[JEgNA
	void ClearErrCount();

	//hbvƃXNũJEg擾
	//F
	// drop				[OUT]hbv
	// scramble			[OUT]XNu
	void GetErrCount(ULONGLONG* drop, ULONGLONG* scramble);


	//^撆̃t@C̃t@CpX擾
	//F
	// filePath			[OUT]ۑt@C
	// subRecFlag		[OUT]Tu^悪ǂ
	void GetSaveFilePath(
		wstring* filePath,
		BOOL* subRecFlag
		);

	//hbvƃXNũJEgۑ
	//F
	// filePath			[IN]ۑt@C
	void SaveErrCount(
		wstring filePath
		);

	void SetSignalLevel(
		float signalLv
		);

	//^撆̃t@C̏o̓TCY擾
	//F
	// writeSize			[OUT]ۑt@C
	void GetRecWriteSize(
		__int64* writeSize
		);

	void SetBonDriver(
		wstring bonDriver
		);
	void SetPIDName(
		map<WORD, string>* pidName
		);
protected:
	DWORD id;
	WORD SID;

	CEpgDataCap3Util* epgUtil;

	BOOL enableScramble;

	vector<HANDLE> udpPortMutex;
	vector<HANDLE> tcpPortMutex;

	CSendUDP* sendUdp;
	CSendTCP* sendTcp;
	CWriteTSFile* writeFile;

	BYTE* buff;
	DWORD buffSize;
	DWORD buffWriteSize;

	CCreatePATPacket createPat;
	CCreatePMTPacket createPmt;

	WORD pmtPID;
	map<WORD,WORD> emmPIDMap;

	CDropCount dropCount;

	BOOL pittariStart;
	BOOL pittariEndChk;

	WORD lastPMTVer;

	wstring fileName;
	BOOL overWriteFlag;
	ULONGLONG createSize;
	vector<REC_FILE_SET_INFO> saveFolder;
	vector<wstring> saveFolderSub;
	WORD pittariONID;
	WORD pittariTSID;
	WORD pittariSID;
	WORD pittariEventID;
	wstring pittariRecFilePath;
	int maxBuffCount;

protected:
	BOOL WriteData(BYTE* data, DWORD size);

	void StratPittariRec();
	void StopPittariRec();
};

