#pragma once

#include <Windows.h>

#include "../Common/Util.h"
#include "../Common/StructDef.h"
#include "../Common/PathUtil.h"
#include "../Common/StringUtil.h"
#include "../Common/ErrDef.h"
#include "../Common/EpgDataCap3Util.h"
#include "../Common/TSPacketUtil.h"

#include "BonCtrlDef.h"
#include "ScrambleDecoderUtil.h"
#include "CreatePATPacket.h"
#include "OneServiceUtil.h"
#include "PMTUtil.h"
#include "CATUtil.h"

class CTSOut
{
public:
	CTSOut(void);
	~CTSOut(void);

	DWORD SetChChangeEvent(BOOL resetEpgUtil = FALSE);
	BOOL IsChChanging(BOOL* chChgErr);
	void ResetChChange();

	//݂̃Xg[ID擾
	//߂lF
	// TRUEijAFALSEisj
	//F
	// ONID		[OUT]originalNetworkID
	// TSID		[OUT]transportStreamID
	BOOL GetStreamID(
		WORD* ONID,
		WORD* TSID
		);

	DWORD AddTSBuff(TS_DATA* data);

	//EMM̓ݒ
	//߂lF
	// TRUEijAFALSEisj
	//F
	// enable		[IN] TRUEijAFALSEiȂj
	BOOL SetEmm(
		BOOL enable
		);

	//EMMs
	//߂lF
	// 
	DWORD GetEmmCount();

	//DLL̃[hԂ擾
	//߂lF
	// TRUEi[hɐĂjAFALSEi[hɎsĂj
	//F
	// loadErrDll		[OUT][hɎsDLLt@C
	BOOL GetLoadStatus(
		wstring& loadErrDll
		);

	//EPGf[^̕ۑJn
	//߂lF
	// TRUEijAFALSEisj
	BOOL StartSaveEPG(
		wstring epgFilePath
		);

	//EPGf[^̕ۑI
	//߂lF
	// TRUEijAFALSEisj
	//F
	// copy			[IN]tmpRs[sǂ
	BOOL StopSaveEPG(
		BOOL copy
		);

	//EPGf[^̒~ϏԂZbg
	void ClearSectionStatus();

	//EPGf[^̒~ϏԂ擾
	//߂lF
	// Xe[^X
	//F
	// l_eitFlag		[IN]L-EIT̃Xe[^X擾
	EPG_SECTION_STATUS GetSectionStatus(
		BOOL l_eitFlag
		);

	//Xg[̃T[rXꗗ擾
	//߂lF
	// G[R[h
	//F
	// serviceListSize			[OUT]serviceLisť
	// serviceList				[OUT]T[rX̃XgiDLLŎIdeleteBɎ擾s܂ŗLj
	DWORD GetServiceListActual(
		DWORD* serviceListSize,
		SERVICE_INFO** serviceList
		);

	//TSXg[pRg[쐬
	//߂lF
	// TRUEijAFALSEis
	//F
	// id			[OUT]䎯ID
	BOOL CreateServiceCtrl(
		DWORD* id
		);

	//TSXg[pRg[쐬
	//߂lF
	// TRUEijAFALSEis
	//F
	// id			[IN]䎯ID
	BOOL DeleteServiceCtrl(
		DWORD id
		);

	//Ώۂ̃T[rXݒ肷
	//߂lF
	// TRUEijAFALSEis
	//F
	// id			[IN]䎯ID
	// serviceID	[IN]ΏۃT[rXIDA0xFFFFőST[rXΏ
	BOOL SetServiceID(
		DWORD id,
		WORD serviceID
		);

	BOOL GetServiceID(
		DWORD id,
		WORD* serviceID
		);

	//UDPőMs
	//߂lF
	// TRUEijAFALSEisj
	//F
	// id			[IN]䎯ID
	// sendList		[IN/OUT]M惊XgBNULLŒ~BPort͎ۂɑMɎgpPortԂB
	BOOL SendUdp(
		DWORD id,
		vector<NW_SEND_INFO>* sendList
		);

	//TCPőMs
	//߂lF
	// TRUEijAFALSEisj
	//F
	// id			[IN]䎯ID
	// sendList		[IN/OUT]M惊XgBNULLŒ~BPort͎ۂɑMɎgpPortԂB
	BOOL SendTcp(
		DWORD id,
		vector<NW_SEND_INFO>* sendList
		);

	//t@CۑJn
	//߂lF
	// TRUEijAFALSEisj
	//F
	// id					[IN]䎯ID
	// fileName				[IN]ۑt@CpX
	// overWriteFlag		[IN]t@Cݎɏ㏑邩ǂiTRUEFAFALSEFȂj
	// pittariFlag			[IN]҂胂[hiTRUEFAFALSEFȂj
	// pittariONID			[IN]҂胂[hŘ^悷ONID
	// pittariTSID			[IN]҂胂[hŘ^悷TSID
	// pittariSID			[IN]҂胂[hŘ^悷SID
	// pittariEventID		[IN]҂胂[hŘ^悷CxgID
	// createSize			[IN]t@C쐬ɃfBXNɗ\񂷂e
	// saveFolder			[IN]gptH_ꗗ
	// saveFolderSub		[IN]HDD̋󂫂ȂȂꍇɈꎞIɎgptH_
	BOOL StartSave(
		DWORD id,
		wstring fileName,
		BOOL overWriteFlag,
		BOOL pittariFlag,
		WORD pittariONID,
		WORD pittariTSID,
		WORD pittariSID,
		WORD pittariEventID,
		ULONGLONG createSize,
		vector<REC_FILE_SET_INFO>* saveFolder,
		vector<wstring>* saveFolderSub,
		int maxBuffCount
	);

	//t@CۑI
	//߂lF
	// TRUEijAFALSEisj
	//F
	// id			[IN]䎯ID
	BOOL EndSave(
		DWORD id
		);

	//XNu̓ݒ
	//߂lF
	// TRUEijAFALSEisj
	//F
	// enable		[IN] TRUEijAFALSEiȂj
	BOOL SetScramble(
		DWORD id,
		BOOL enable
		);

	//ƃf[^܂߂邩ǂ
	//F
	// id					[IN]䎯ID
	// enableCaption		[IN] TRUEi܂߂jAFALSEi܂߂Ȃj
	// enableData			[IN]f[^ TRUEi܂߂jAFALSEi܂߂Ȃj
	void SetServiceMode(
		DWORD id,
		BOOL enableCaption,
		BOOL enableData
		);

	//G[JEgNA
	void ClearErrCount(
		DWORD id
		);

	//hbvƃXNũJEg擾
	//F
	// drop				[OUT]hbv
	// scramble			[OUT]XNu
	void GetErrCount(
		DWORD id,
		ULONGLONG* drop,
		ULONGLONG* scramble
		);

	//^撆̃t@C̏o̓TCY擾
	//F
	// id					[IN]䎯ID
	// writeSize			[OUT]ۑt@C
	void GetRecWriteSize(
		DWORD id,
		__int64* writeSize
		);

	//wT[rX̌orEPG擾
	//߂lF
	// G[R[h
	//F
	// originalNetworkID		[IN]擾ΏۂoriginalNetworkID
	// transportStreamID		[IN]擾ΏۂtransportStreamID
	// serviceID				[IN]擾ΏۂServiceID
	// nextFlag					[IN]TRUEi̔ԑgjAFALSEi݂̔ԑgj
	// epgInfo					[OUT]EPGiDLLŎIdeleteBɎ擾s܂ŗLj
	DWORD GetEpgInfo(
		WORD originalNetworkID,
		WORD transportStreamID,
		WORD serviceID,
		BOOL nextFlag,
		EPGDB_EVENT_INFO* epgInfo
		);
	
	//wCxgEPG擾
	//߂lF
	// G[R[h
	//F
	// originalNetworkID		[IN]擾ΏۂoriginalNetworkID
	// transportStreamID		[IN]擾ΏۂtransportStreamID
	// serviceID				[IN]擾ΏۂServiceID
	// eventID					[IN]擾ΏۂEventID
	// pfOnlyFlag				[IN]p/f̂݌邩ǂ
	// epgInfo					[OUT]EPGiDLLŎIdeleteBɎ擾s܂ŗLj
	DWORD SearchEpgInfo(
		WORD originalNetworkID,
		WORD transportStreamID,
		WORD serviceID,
		WORD eventID,
		BYTE pfOnlyFlag,
		EPGDB_EVENT_INFO* epgInfo
		);

	//PCvƂXg[ԂƂ̍擾
	//߂lF
	// ̕b
	int GetTimeDelay(
		);
	
	//^撆ǂ
	//߂lF
	// TRUEi^撆jAFALSEiĂȂj
	BOOL IsRec();

	//^撆̃t@C̃t@CpX擾
	//F
	// id					[IN]䎯ID
	// filePath				[OUT]ۑt@C
	// subRecFlag			[OUT]Tu^悪ǂ
	void GetSaveFilePath(
		DWORD id,
		wstring* filePath,
		BOOL* subRecFlag
		);

	//hbvƃXNũJEgۑ
	//F
	// id					[IN]䎯ID
	// filePath				[IN]ۑt@C
	void SaveErrCount(
		DWORD id,
		wstring filePath
		);

	void SetSignalLevel(
		float signalLv
		);

	void SetBonDriver(
		wstring bonDriver
		);

protected:
	HANDLE lockEvent;

	CEpgDataCap3Util epgUtil;
	CScrambleDecoderUtil decodeUtil;
	CCreatePATPacket patUtil;

	BOOL chChangeFlag;
	BOOL chChangeErr;
	LONGLONG chChangeTime;
	WORD lastONID;
	WORD lastTSID;

	BYTE* decodeBuff;
	DWORD decodeBuffSize;
	DWORD deocdeBuffWriteSize;

	BOOL enableDecodeFlag;
	BOOL emmEnableFlag;
	BOOL serviceOnlyFlag;

	map<DWORD, COneServiceUtil*> serviceUtilMap; //L[ID
	map<WORD, CPMTUtil*> pmtUtilMap; //L[PMTPID
	CCATUtil* catUtil;

	map<WORD,WORD> needPIDMap; //L[PID

	DWORD nextCtrlID;

	HANDLE epgFile;
	wstring epgFilePath;
	wstring epgTempFilePath;

	wstring bonFile;
protected:
	//PublicAPIrp
	BOOL Lock(LPCWSTR log = NULL, DWORD timeOut = 30*1000);
	void UnLock(LPCWSTR log = NULL);

	void CheckNeedPID();
	BOOL IsNeedPID(CTSPacketUtil* packet);

	DWORD GetNextID();

	//EPGf[^Rs[
	BOOL ConvertEpgInfo(EPG_EVENT_INFO* src, EPGDB_EVENT_INFO* dest);

	void ResetErrCount();
};

