#ifndef __DESCRIPTOR_DEF_H__
#define __DESCRIPTOR_DEF_H__

#include "CADesc.h"
#include "AudioComponentDesc.h"
#include "AVCTimingHRDDesc.h"
#include "AVCVideoDesc.h"
#include "BoardInfoDesc.h"
#include "BouquetNameDesc.h"
#include "BroadcasterNameDesc.h"
#include "CAIdentifierDesc.h"
#include "ComponentDesc.h"
#include "ComponentGroupDesc.h"
#include "ConnectedTransmissionDesc.h"
#include "ContentAvailabilityDesc.h"
#include "ContentDesc.h"
#include "CountryAvailabilityDesc.h"
#include "DataComponentDesc.h"
#include "DataContentDesc.h"
#include "DigitalCopyCtrlDesc.h"
#include "EmergencyInfoDesc.h"
#include "EventGroupDesc.h"
#include "ExtendedBroadcasterDesc.h"
#include "ExtendedEventDesc.h"
#include "HierarchicalTransmissionDesc.h"
#include "HyperlinkDesc.h"
#include "LDTLinkageDesc.h"
#include "LinkageDesc.h"
#include "LocalTimeOffsetDesc.h"
#include "LogoTransmissionDesc.h"
#include "MosaicDesc.h"
#include "NetworkNameDesc.h"
#include "NVODReferenceDesc.h"
#include "ParentalRatingDesc.h"
#include "PartialReceptionDesc.h"
#include "SatelliteDeliverySysDesc.h"
#include "SeriesDesc.h"
#include "ServiceDesc.h"
#include "ServiceGroupDesc.h"
#include "ServiceListDesc.h"
#include "ShortEventDesc.h"
#include "SIParameterDesc.h"
#include "SIPrime_tsDesc.h"
#include "StreamIdentifierDesc.h"
#include "StuffingDesc.h"
#include "SystemManagementDesc.h"
#include "TargetRegionDesc.h"
#include "TerrestrialDeliverySysDesc.h"
#include "TimeShiftedEventDesc.h"
#include "TimeShiftedServiceDesc.h"
#include "TSInfoDesc.h"
#include "VideoDecodeCtrlDesc.h"
#include "PartialTransportStreamDesc.h"
#include "NetworkIdentification.h"
#include "PartialTSTimeDesc.h"
#include "DownloadContentDesc.h"

typedef struct _DESCRIPTOR_DATA{
	CCADesc* CA;
	CAudioComponentDesc* audioComponent;
	CAVCTimingHRDDesc*	AVCTimingHRD;
	CAVCVideoDesc* AVCVideo;
	CBoardInfoDesc* boardInfo;
	CBouquetNameDesc* bouquetName;
	CBroadcasterNameDesc* broadcasterName;
	CCAIdentifierDesc* CAIdentifier;
	CComponentDesc* component;
	CComponentGroupDesc* componentGroup;
	CConnectedTransmissionDesc* connectedTransmission;
	CContentAvailabilityDesc* contentAvailability;
	CContentDesc* content;
	CCountryAvailabilityDesc* countryAvailability;
	CDataComponentDesc* dataComponent;
	CDataContentDesc* dataContent;
	CDigitalCopyCtrlDesc* digitalCopyCtrl;
	CEmergencyInfoDesc* emergencyInfo;
	CEventGroupDesc* eventGroup;
	CExtendedBroadcasterDesc* extendedBroadcaster;
	CExtendedEventDesc* extendedEvent;
	CHierarchicalTransmissionDesc* hierarchicalTransmission;
	CHyperlinkDesc* hyperlink;
	CLDTLinkageDesc* LDTLinkage;
	CLinkageDesc* linkage;
	CLocalTimeOffsetDesc* localTimeOffset;
	CLogoTransmissionDesc* logoTransmission;
	CMosaicDesc* mosaic;
	CNetworkNameDesc* networkName;
	CNVODReferenceDesc* NVODReference;
	CParentalRatingDesc* parentalRating;
	CPartialReceptionDesc* partialReception;
	CSatelliteDeliverySysDesc* satelliteDeliverySys;
	CSeriesDesc* series;
	CServiceDesc* service;
	CServiceGroupDesc* serviceGroup;
	CServiceListDesc* serviceList;
	CShortEventDesc* shortEvent;
	CSIParameterDesc* SIParameter;
	CSIPrime_tsDesc* SIPrime_ts;
	CStreamIdentifierDesc* streamIdentifier;
	CStuffingDesc* stuffing;
	CSystemManagementDesc* systemManagement;
	CTargetRegionDesc* targetRegion;
	CTerrestrialDeliverySysDesc* terrestrialDeliverySys;
	CTimeShiftedEventDesc* timeShiftedEvent;
	CTimeShiftedServiceDesc* timeShiftedService;
	CTSInfoDesc* TSInfo;
	CVideoDecodeCtrlDesc* videoDecodeCtrl;
	CPartialTransportStreamDesc* partialTransportStream;
	CNetworkIdentification* networkIdentification;
	CPartialTSTimeDesc* partialTSTime;
	CDownloadContentDesc* downloadContent;

	_DESCRIPTOR_DATA(void){
		CA = NULL;
		audioComponent = NULL;
		AVCTimingHRD = NULL;
		AVCVideo = NULL;
		boardInfo = NULL;
		bouquetName = NULL;
		broadcasterName = NULL;
		CAIdentifier = NULL;
		component = NULL;
		componentGroup = NULL;
		connectedTransmission = NULL;
		contentAvailability = NULL;
		content = NULL;
		countryAvailability = NULL;
		dataComponent = NULL;
		dataContent = NULL;
		digitalCopyCtrl = NULL;
		emergencyInfo = NULL;
		eventGroup = NULL;
		extendedBroadcaster = NULL;
		extendedEvent = NULL;
		hierarchicalTransmission = NULL;
		hyperlink = NULL;
		LDTLinkage = NULL;
		linkage = NULL;
		localTimeOffset = NULL;
		logoTransmission = NULL;
		mosaic = NULL;
		networkName = NULL;
		NVODReference = NULL;
		parentalRating = NULL;
		partialReception = NULL;
		satelliteDeliverySys = NULL;
		series = NULL;
		service = NULL;
		serviceGroup = NULL;
		serviceList = NULL;
		shortEvent = NULL;
		SIParameter = NULL;
		SIPrime_ts = NULL;
		streamIdentifier = NULL;
		stuffing = NULL;
		systemManagement = NULL;
		targetRegion = NULL;
		terrestrialDeliverySys = NULL;
		timeShiftedEvent = NULL;
		timeShiftedService = NULL;
		TSInfo = NULL;
		videoDecodeCtrl = NULL;
		partialTransportStream = NULL;
		networkIdentification = NULL;
		partialTSTime = NULL;
		downloadContent = NULL;
	};
	~_DESCRIPTOR_DATA(void){
		SAFE_DELETE(CA);
		SAFE_DELETE(audioComponent);
		SAFE_DELETE(AVCTimingHRD);
		SAFE_DELETE(AVCVideo);
		SAFE_DELETE(boardInfo);
		SAFE_DELETE(bouquetName);
		SAFE_DELETE(broadcasterName);
		SAFE_DELETE(CAIdentifier);
		SAFE_DELETE(component);
		SAFE_DELETE(componentGroup);
		SAFE_DELETE(connectedTransmission);
		SAFE_DELETE(contentAvailability);
		SAFE_DELETE(content);
		SAFE_DELETE(countryAvailability);
		SAFE_DELETE(dataComponent);
		SAFE_DELETE(dataContent);
		SAFE_DELETE(digitalCopyCtrl);
		SAFE_DELETE(emergencyInfo);
		SAFE_DELETE(eventGroup);
		SAFE_DELETE(extendedBroadcaster);
		SAFE_DELETE(extendedEvent);
		SAFE_DELETE(hierarchicalTransmission);
		SAFE_DELETE(hyperlink);
		SAFE_DELETE(LDTLinkage);
		SAFE_DELETE(linkage);
		SAFE_DELETE(localTimeOffset);
		SAFE_DELETE(logoTransmission);
		SAFE_DELETE(mosaic);
		SAFE_DELETE(networkName);
		SAFE_DELETE(NVODReference);
		SAFE_DELETE(parentalRating);
		SAFE_DELETE(partialReception);
		SAFE_DELETE(satelliteDeliverySys);
		SAFE_DELETE(series);
		SAFE_DELETE(service);
		SAFE_DELETE(serviceGroup);
		SAFE_DELETE(serviceList);
		SAFE_DELETE(shortEvent);
		SAFE_DELETE(SIParameter);
		SAFE_DELETE(SIPrime_ts);
		SAFE_DELETE(streamIdentifier);
		SAFE_DELETE(stuffing);
		SAFE_DELETE(systemManagement);
		SAFE_DELETE(targetRegion);
		SAFE_DELETE(terrestrialDeliverySys);
		SAFE_DELETE(timeShiftedEvent);
		SAFE_DELETE(timeShiftedService);
		SAFE_DELETE(TSInfo);
		SAFE_DELETE(videoDecodeCtrl);
		SAFE_DELETE(partialTransportStream);
		SAFE_DELETE(networkIdentification);
		SAFE_DELETE(partialTSTime);
		SAFE_DELETE(downloadContent);
	};
}DESCRIPTOR_DATA;

//////////////////////////////////////////////////////
//Mʂ̊
typedef struct _CA_SYSTEM_TABLE{
	WORD CA_system_id;
	wstring name;
} CA_SYSTEM_TABLE;

static CA_SYSTEM_TABLE CASystemIDTable[]={
	{ 0x0001, L"XJp[M" },
	{ 0x0003, L"" },
	{ 0x0004, L"Secure Navi" },
	{ 0x0005, L"ARIBM" },
	{ 0x0006, L"CATVM" },
	{ 0x0007, L"P[u{" },
	{ 0x0008, L"u-CAS" },
	{ 0x0009, L"PowerKEY" },
	{ 0x000A, L"ARIBMB" },
	{ 0x000B, L"pCVXM" },
	{ 0x000C, L"MULTI2-NAGRA" },
	{ 0x000D, L"IPTVtH[EMarlin" }
};
//->Mʂ̊

//////////////////////////////////////////////////////
//R|[lgeƃR|[lg
typedef struct _COMPONENT_TYPE_TABLE{
	BYTE stream_content;
	BYTE component_type;
	wstring name;
} COMPONENT_TYPE_TABLE;

static COMPONENT_TYPE_TABLE componentTypeTable[]={
	{ 0x01, 0x01, L"f480i(525i)AAXyNg4:3" },
	{ 0x01, 0x02, L"f480i(525i)AAXyNg16:9 pxNg" },
	{ 0x01, 0x03, L"f480i(525i)AAXyNg16:9 pxNgȂ" },
	{ 0x01, 0x04, L"f480i(525i)AAXyNg > 16:9" },
	{ 0x01, 0x91, L"f2160pAAXyNg4:3" },
	{ 0x01, 0x92, L"f2160pAAXyNg16:9 pxNg" },
	{ 0x01, 0x93, L"f2160pAAXyNg16:9 pxNgȂ" },
	{ 0x01, 0x94, L"f2160pAAXyNg > 16:9" },
	{ 0x01, 0xA1, L"f480p(525p)AAXyNg4:3" },
	{ 0x01, 0xA2, L"f480p(525p)AAXyNg16:9 pxNg" },
	{ 0x01, 0xA3, L"f480p(525p)AAXyNg16:9 pxNgȂ" },
	{ 0x01, 0xA4, L"f480p(525p)AAXyNg > 16:9" },
	{ 0x01, 0xB1, L"f1080i(1125i)AAXyNg4:3" },
	{ 0x01, 0xB2, L"f1080i(1125i)AAXyNg16:9 pxNg" },
	{ 0x01, 0xB3, L"f1080i(1125i)AAXyNg16:9 pxNgȂ" },
	{ 0x01, 0xB4, L"f1080i(1125i)AAXyNg > 16:9" },
	{ 0x01, 0xC1, L"f720p(750p)AAXyNg4:3" },
	{ 0x01, 0xC2, L"f720p(750p)AAXyNg16:9 pxNg" },
	{ 0x01, 0xC3, L"f720p(750p)AAXyNg16:9 pxNgȂ" },
	{ 0x01, 0xC4, L"f720p(750p)AAXyNg > 16:9" },
	{ 0x01, 0xD1, L"f240p AXyNg4:3" },
	{ 0x01, 0xD2, L"f240p AXyNg16:9 pxNg" },
	{ 0x01, 0xD3, L"f240p AXyNg16:9 pxNgȂ" },
	{ 0x01, 0xD4, L"f240p AXyNg > 16:9" },
	{ 0x01, 0xE1, L"f1080p(1125p)AAXyNg4:3" },
	{ 0x01, 0xE2, L"f1080p(1125p)AAXyNg16:9 pxNg" },
	{ 0x01, 0xE3, L"f1080p(1125p)AAXyNg16:9 pxNgȂ" },
	{ 0x01, 0xE4, L"f1080p(1125p)AAXyNg > 16:9" },
	{ 0x02, 0x01, L"A1/0[hiVOmj" },
	{ 0x02, 0x02, L"A1/0{1/0[hifAmj" },
	{ 0x02, 0x03, L"A2/0[hiXeIj" },
	{ 0x02, 0x04, L"A2/1[h" },
	{ 0x02, 0x05, L"A3/0[h" },
	{ 0x02, 0x06, L"A2/2[h" },
	{ 0x02, 0x07, L"A3/1[h" },
	{ 0x02, 0x08, L"A3/2[h" },
	{ 0x02, 0x09, L"A3/2{LFE[hi3/2.1[hj" },
	{ 0x02, 0x0A, L"A3/3.1[h" },
	{ 0x02, 0x0B, L"A2/0/0-2/0/2-0.1[h" },
	{ 0x02, 0x0C, L"A5/2.1[h" },
	{ 0x02, 0x0D, L"A3/2/2.1[h" },
	{ 0x02, 0x0E, L"A2/0/0-3/0/2-0.1[h" },
	{ 0x02, 0x0F, L"A0/2/0-3/0/2-0.1[h" },
	{ 0x02, 0x10, L"A2/0/0-3/2/3-0.2[h" },
	{ 0x02, 0x11, L"A3/3/3-5/2/3-3/0/0.2[h" },
	{ 0x02, 0x40, L"oQҗp" },
	{ 0x02, 0x41, L"oQҗp" },
	{ 0x05, 0x01, L"H.264|MPEG-4 AVCAf480i(525i)AAXyNg4:3" },
	{ 0x05, 0x02, L"H.264|MPEG-4 AVCAf480i(525i)AAXyNg16:9 pxNg" },
	{ 0x05, 0x03, L"H.264|MPEG-4 AVCAf480i(525i)AAXyNg16:9 pxNgȂ" },
	{ 0x05, 0x04, L"H.264|MPEG-4 AVCAf480i(525i)AAXyNg > 16:9" },
	{ 0x05, 0x91, L"H.264|MPEG-4 AVCAf2160pAAXyNg4:3" },
	{ 0x05, 0x92, L"H.264|MPEG-4 AVCAf2160pAAXyNg16:9 pxNg" },
	{ 0x05, 0x93, L"H.264|MPEG-4 AVCAf2160pAAXyNg16:9 pxNgȂ" },
	{ 0x05, 0x94, L"H.264|MPEG-4 AVCAf2160pAAXyNg > 16:9" },
	{ 0x05, 0xA1, L"H.264|MPEG-4 AVCAf480p(525p)AAXyNg4:3" },
	{ 0x05, 0xA2, L"H.264|MPEG-4 AVCAf480p(525p)AAXyNg16:9 pxNg" },
	{ 0x05, 0xA3, L"H.264|MPEG-4 AVCAf480p(525p)AAXyNg16:9 pxNgȂ" },
	{ 0x05, 0xA4, L"H.264|MPEG-4 AVCAf480p(525p)AAXyNg > 16:9" },
	{ 0x05, 0xB1, L"H.264|MPEG-4 AVCAf1080i(1125i)AAXyNg4:3" },
	{ 0x05, 0xB2, L"H.264|MPEG-4 AVCAf1080i(1125i)AAXyNg16:9 pxNg" },
	{ 0x05, 0xB3, L"H.264|MPEG-4 AVCAf1080i(1125i)AAXyNg16:9 pxNgȂ" },
	{ 0x05, 0xB4, L"H.264|MPEG-4 AVCAf1080i(1125i)AAXyNg > 16:9" },
	{ 0x05, 0xC1, L"H.264|MPEG-4 AVCAf720p(750p)AAXyNg4:3" },
	{ 0x05, 0xC2, L"H.264|MPEG-4 AVCAf720p(750p)AAXyNg16:9 pxNg" },
	{ 0x05, 0xC3, L"H.264|MPEG-4 AVCAf720p(750p)AAXyNg16:9 pxNgȂ" },
	{ 0x05, 0xC4, L"H.264|MPEG-4 AVCAf720p(750p)AAXyNg > 16:9" },
	{ 0x05, 0xD1, L"H.264|MPEG-4 AVCAf240p AXyNg4:3" },
	{ 0x05, 0xD2, L"H.264|MPEG-4 AVCAf240p AXyNg16:9 pxNg" },
	{ 0x05, 0xD3, L"H.264|MPEG-4 AVCAf240p AXyNg16:9 pxNgȂ" },
	{ 0x05, 0xD4, L"H.264|MPEG-4 AVCAf240p AXyNg > 16:9" },
	{ 0x05, 0xE1, L"H.264|MPEG-4 AVCAf1080p(1125p)AAXyNg4:3" },
	{ 0x05, 0xE2, L"H.264|MPEG-4 AVCAf1080p(1125p)AAXyNg16:9 pxNg" },
	{ 0x05, 0xE3, L"H.264|MPEG-4 AVCAf1080p(1125p)AAXyNg16:9 pxNgȂ" },
	{ 0x05, 0xE4, L"H.264|MPEG-4 AVCAf1080p(1125p)AAXyNg > 16:9" }
};
//->R|[lgeƃR|[lg

//////////////////////////////////////////////////////
//RegLqqɂWw
typedef struct _NIBBLE_TABLE_1{
	BYTE content_nibble_level_1;
	wstring name;
} NIBBLE_TABLE_1;

static NIBBLE_TABLE_1 nibbleTable1[]={
	{ 0x00, L"j[X^" },
	{ 0x01, L"X|[c" },
	{ 0x02, L"^ChV[" },
	{ 0x03, L"h}" },
	{ 0x04, L"y" },
	{ 0x05, L"oGeB" },
	{ 0x06, L"f" },
	{ 0x07, L"Aj^B" },
	{ 0x08, L"hL^[^{" },
	{ 0x09, L"^" },
	{ 0x0A, L"^" },
	{ 0x0B, L"" },
	{ 0x0E, L"g" },
	{ 0x0F, L"̑" },
};

typedef struct _NIBBLE_TABLE_2{
	BYTE content_nibble_level_1;
	BYTE content_nibble_level_2;
	wstring name;
} NIBBLE_TABLE_2;

static NIBBLE_TABLE_2 nibbleTable2[]={
	{ 0x00, 0x00, L"莞E" },
	{ 0x00, 0x01, L"VC" },
	{ 0x00, 0x02, L"WEhLg" },
	{ 0x00, 0x03, L"E" },
	{ 0x00, 0x04, L"oρEs" },
	{ 0x00, 0x05, L"COE" },
	{ 0x00, 0x06, L"" },
	{ 0x00, 0x07, L"_Ek" },
	{ 0x00, 0x08, L"񓹓" },
	{ 0x00, 0x09, L"[JEn" },
	{ 0x00, 0x0A, L"" },
	{ 0x00, 0x0F, L"̑" },
	{ 0x01, 0x00, L"X|[cj[X" },
	{ 0x01, 0x01, L"싅" },
	{ 0x01, 0x02, L"TbJ[" },
	{ 0x01, 0x03, L"St" },
	{ 0x01, 0x04, L"̑̋Z" },
	{ 0x01, 0x05, L"oEiZ" },
	{ 0x01, 0x06, L"IsbNEۑ" },
	{ 0x01, 0x07, L"}\EEj" },
	{ 0x01, 0x08, L"[^[X|[c" },
	{ 0x01, 0x09, L"}EEB^[X|[c" },
	{ 0x01, 0x0A, L"nEcZ" },
	{ 0x01, 0x0F, L"̑" },
	{ 0x02, 0x00, L"|\EChV[" },
	{ 0x02, 0x01, L"t@bV" },
	{ 0x02, 0x02, L"炵EZ܂" },
	{ 0x02, 0x03, L"NE" },
	{ 0x02, 0x04, L"VbsOEʔ" },
	{ 0x02, 0x05, L"OE" },
	{ 0x02, 0x06, L"Cxg" },
	{ 0x02, 0x07, L"ԑgЉEm点" },
	{ 0x02, 0x0F, L"̑" },
	{ 0x03, 0x00, L"h}" },
	{ 0x03, 0x01, L"COh}" },
	{ 0x03, 0x02, L"㌀" },
	{ 0x03, 0x0F, L"̑" },
	{ 0x04, 0x00, L"bNE|bvX" },
	{ 0x04, 0x01, L"CObNE|bvX" },
	{ 0x04, 0x02, L"NVbNEIy" },
	{ 0x04, 0x03, L"WYEt[W" },
	{ 0x04, 0x04, L"̗wȁE" },
	{ 0x04, 0x05, L"CuERT[g" },
	{ 0x04, 0x06, L"LOENGXg" },
	{ 0x04, 0x07, L"JIPÊǎ" },
	{ 0x04, 0x08, L"wEMy" },
	{ 0x04, 0x09, L"wELbY" },
	{ 0x04, 0x0A, L"yE[h~[WbN" },
	{ 0x04, 0x0F, L"̑" },
	{ 0x05, 0x00, L"NCY" },
	{ 0x05, 0x01, L"Q[" },
	{ 0x05, 0x02, L"g[NoGeB" },
	{ 0x05, 0x03, L"΂ERfB" },
	{ 0x05, 0x04, L"yoGeB" },
	{ 0x05, 0x05, L"oGeB" },
	{ 0x05, 0x06, L"oGeB" },
	{ 0x05, 0x0F, L"̑" },
	{ 0x06, 0x00, L"m" },
	{ 0x06, 0x01, L"M" },
	{ 0x06, 0x02, L"Aj" },
	{ 0x06, 0x0F, L"̑" },
	{ 0x07, 0x00, L"Aj" },
	{ 0x07, 0x01, L"COAj" },
	{ 0x07, 0x02, L"B" },
	{ 0x07, 0x0F, L"̑" },
	{ 0x08, 0x00, L"ЉE" },
	{ 0x08, 0x01, L"jEIs" },
	{ 0x08, 0x02, L"REE" },
	{ 0x08, 0x03, L"FEȊwEw" },
	{ 0x08, 0x04, L"J`[E`" },
	{ 0x08, 0x05, L"wE|" },
	{ 0x08, 0x06, L"X|[c" },
	{ 0x08, 0x07, L"hL^[S" },
	{ 0x08, 0x08, L"C^r[E_" },
	{ 0x08, 0x0F, L"̑" },
	{ 0x09, 0x00, L"㌀EV" },
	{ 0x09, 0x01, L"~[WJ" },
	{ 0x09, 0x02, L"_XEoG" },
	{ 0x09, 0x03, L"E|" },
	{ 0x09, 0x04, L"̕EÓT" },
	{ 0x09, 0x0F, L"̑" },
	{ 0x0A, 0x00, L"EނEAEghA" },
	{ 0x0A, 0x01, L"|EybgE|" },
	{ 0x0A, 0x02, L"yEpEH|" },
	{ 0x0A, 0x03, L"͌E" },
	{ 0x0A, 0x04, L"Ep`R" },
	{ 0x0A, 0x05, L"ԁEI[goC" },
	{ 0x0A, 0x06, L"Rs[^EsuQ[" },
	{ 0x0A, 0x07, L"bEw" },
	{ 0x0A, 0x08, L"cEw" },
	{ 0x0A, 0x09, L"wEZ" },
	{ 0x0A, 0x0A, L"wE" },
	{ 0x0A, 0x0B, L"UEi" },
	{ 0x0A, 0x0C, L"" },
	{ 0x0A, 0x0F, L"̑" },
	{ 0x0B, 0x00, L"" },
	{ 0x0B, 0x01, L"Q" },
	{ 0x0B, 0x02, L"Љ" },
	{ 0x0B, 0x03, L"{eBA" },
	{ 0x0B, 0x04, L"b" },
	{ 0x0B, 0x05, L"ij" },
	{ 0x0B, 0x06, L"" },
	{ 0x0E, 0x0F, L"̑" },
	{ 0x0E, 0x00, L"BS/nfW^pԑgt" },
	{ 0x0E, 0x01, L"LшCS fW^pg" },
	{ 0x0E, 0x02, L"qfW^pg" },
	{ 0x0E, 0x03, L"T[o[^ԑgt" },
	{ 0x0E, 0x04, L"IP pԑgt" }
};
//->RegLqqɂWw

//////////////////////////////////////////////////////
//T[rX`
typedef struct _SERVICE_TYPE_TABLE{
	BYTE service_type;
	wstring name;
} SERVICE_TYPE_TABLE;

static SERVICE_TYPE_TABLE serviceTypeTable[]={
	{ 0x01, L"fW^suT[rX" },
	{ 0x02, L"fW^T[rX" },
	{ 0xA1, L"ՎfT[rX" },
	{ 0xA2, L"ՎT[rX" },
	{ 0xA3, L"Վf[^T[rX" },
	{ 0xA4, L"GWjAOT[rX" },
	{ 0xA5, L"v[VfT[rX" },
	{ 0xA6, L"v[VT[rX" },
	{ 0xA7, L"v[Vf[^T[rX" },
	{ 0xA8, L"O~ϗpf[^T[rX" },
	{ 0xA9, L"~ϐpf[^T[rX" },
	{ 0xAA, L"ubN}[Nꗗf[^T[rX" },
	{ 0xAB, L"T[o[^TC}T[rX" },
	{ 0xAC, L"Ɨt@CT[rX" },
	{ 0xC0, L"f[^T[rX" },
	{ 0xC1, L"TLVp~ό^T[rX" }
};

//->T[rX`
#endif
