#include "StdAfx.h"
#include "NetworkNameDesc.h"

CNetworkNameDesc::CNetworkNameDesc(void)
{
	char_nameLength = 0;
	char_name = NULL;
}

CNetworkNameDesc::~CNetworkNameDesc(void)
{
	SAFE_DELETE_ARRAY(char_name);
}

BOOL CNetworkNameDesc::Decode( BYTE* data, DWORD dataSize, DWORD* decodeReadSize )
{
	if( data == NULL ){
		return FALSE;
	}
	SAFE_DELETE_ARRAY(char_name);
	char_nameLength = 0;

	//////////////////////////////////////////////////////
	//TCỸ`FbN
	//Œdescriptor_tagdescriptor_length̃TCY͕K{
	if( dataSize < 2 ){
		return FALSE;
	}
	//->TCỸ`FbN

	DWORD readSize = 0;
	//////////////////////////////////////////////////////
	//͏
	descriptor_tag = data[0];
	descriptor_length = data[1];
	readSize += 2;

	if( descriptor_tag != 0x40 ){
		//^Ol
		_OutputDebugString( L"++++CNetworkNameDesc:: descriptor_tag err 0x40 != 0x%02X", descriptor_tag );
		return FALSE;
	}

	if( readSize+descriptor_length > dataSize ){
		//TCYُ
		_OutputDebugString( L"++++CNetworkNameDesc:: size err %d > %d", readSize+descriptor_length, dataSize );
		return FALSE;
	}
	if( descriptor_length > 0 ){
		char_nameLength = descriptor_length;
		char_name = new CHAR[char_nameLength + 1];
		memcpy( char_name, data + readSize, char_nameLength );
		char_name[char_nameLength] = '\0';

		readSize += descriptor_length;
	}else{
		return FALSE;
	}
	//->͏

	if( decodeReadSize != NULL ){
		*decodeReadSize = 2+descriptor_length;
	}

	return TRUE;
}
