#include "StdAfx.h"
#include "EpgDataCap3Main.h"


CEpgDataCap3Main::CEpgDataCap3Main(void)
{
	this->lockEvent = _CreateEvent(FALSE, TRUE, NULL);

	decodeUtilClass.SetEpgDB(&(this->epgDBUtilClass));
}

CEpgDataCap3Main::~CEpgDataCap3Main(void)
{
	if( this->lockEvent != NULL ){
		UnLock();
		CloseHandle(this->lockEvent);
		this->lockEvent = NULL;
	}
}

BOOL CEpgDataCap3Main::Lock(LPCWSTR log, DWORD timeOut)
{
	if( this->lockEvent == NULL ){
		return FALSE;
	}
	if( log != NULL ){
		OutputDebugString(log);
	}
	DWORD dwRet = WaitForSingleObject(this->lockEvent, timeOut);
	if( dwRet == WAIT_ABANDONED || 
		dwRet == WAIT_FAILED){
		return FALSE;
	}
	return TRUE;
}

void CEpgDataCap3Main::UnLock(LPCWSTR log)
{
	if( this->lockEvent != NULL ){
		SetEvent(this->lockEvent);
	}
	if( log != NULL ){
		OutputDebugString(log);
	}
}

//DLL̏
//߂lF
// G[R[h
//F
// asyncMode		[IN]TRUE:񓯊[hAFALSE:[h
DWORD CEpgDataCap3Main::Initialize(
	BOOL asyncFlag
	)
{
	return NO_ERR;
}

//DLL̊J
//߂lF
// G[R[h
DWORD CEpgDataCap3Main::UnInitialize(
	)
{
	return NO_ERR;
}

//͑ΏۂTSpPbgPǂݍ܂
//߂lF
// G[R[h
// data		[IN]TSpPbgP
// size		[IN]datãTCYi188A192ɂȂ͂j
DWORD CEpgDataCap3Main::AddTSPacket(
	BYTE* data,
	DWORD size
	)
{
	if( size < 188 ){
		return ERR_INVALID_ARG;
	}

	if( Lock() == FALSE ) return ERR_FALSE;

	DWORD stratPos = 0;
	if( size > 188 ){
		if( data[0] != 0x47 ){
			if( data[size-188] == 0x47 ){
				stratPos = size-188;
			}else{
				for( DWORD i=0; i<size-188; i++ ){
					if( data[i] == 0x47 ){
						break;
					}else{
						stratPos++;
					}
				}
			}
		}
	}
	DWORD err = this->decodeUtilClass.AddTSData(data+stratPos, 188);
	UnLock();
	return err;
}

//̓f[^݂̌̃Xg[hc擾
//߂lF
// G[R[h
//F
// originalNetworkID		[OUT]݂originalNetworkID
// transportStreamID		[OUT]݂transportStreamID
DWORD CEpgDataCap3Main::GetTSID(
	WORD* originalNetworkID,
	WORD* transportStreamID
	)
{
	if( Lock() == FALSE ) return ERR_FALSE;
	DWORD err = this->decodeUtilClass.GetTSID(originalNetworkID, transportStreamID);
	UnLock();
	return err;
}

//Xg[̃T[rXꗗ擾
//߂lF
// G[R[h
//F
// serviceListSize			[OUT]serviceLisť
// serviceList				[OUT]T[rX̃XgiDLLŎIdeleteBɎ擾s܂ŗLj
DWORD CEpgDataCap3Main::GetServiceListActual(
	DWORD* serviceListSize,
	SERVICE_INFO** serviceList
	)
{
	if( Lock() == FALSE ) return ERR_FALSE;
	DWORD err = this->decodeUtilClass.GetServiceListActual(serviceListSize, serviceList);
	UnLock();
	return err;
}

//~ςꂽEPĜT[rXꗗ擾
//SERVICE_EXT_INFȌ͂Ȃꍇ
//߂lF
// G[R[h
//F
// serviceListSize			[OUT]serviceLisť
// serviceList				[OUT]T[rX̃XgiDLLŎIdeleteBɎ擾s܂ŗLj
DWORD CEpgDataCap3Main::GetServiceListEpgDB(
	DWORD* serviceListSize,
	SERVICE_INFO** serviceList
	)
{
	if( Lock() == FALSE ) return ERR_FALSE;
	DWORD err = this->epgDBUtilClass.GetServiceListEpgDB(serviceListSize, serviceList);
	UnLock();
	return err;
}

//wT[rX̑SEPG擾
//߂lF
// G[R[h
//F
// originalNetworkID		[IN]擾ΏۂoriginalNetworkID
// transportStreamID		[IN]擾ΏۂtransportStreamID
// serviceID				[IN]擾ΏۂServiceID
// epgInfoListSize			[OUT]epgInfoLisť
// epgInfoList				[OUT]EPG̃XgiDLLŎIdeleteBɎ擾s܂ŗLj
DWORD CEpgDataCap3Main::GetEpgInfoList(
	WORD originalNetworkID,
	WORD transportStreamID,
	WORD serviceID,
	DWORD* epgInfoListSize,
	EPG_EVENT_INFO** epgInfoList
	)
{
	if( Lock() == FALSE ) return ERR_FALSE;
	DWORD err = this->epgDBUtilClass.GetEpgInfoList(originalNetworkID, transportStreamID, serviceID, epgInfoListSize, epgInfoList);
	UnLock();
	return err;
}

//wT[rX̌orEPG擾
//߂lF
// G[R[h
//F
// originalNetworkID		[IN]擾ΏۂoriginalNetworkID
// transportStreamID		[IN]擾ΏۂtransportStreamID
// serviceID				[IN]擾ΏۂServiceID
// nextFlag					[IN]TRUEi̔ԑgjAFALSEi݂̔ԑgj
// epgInfo					[OUT]EPGiDLLŎIdeleteBɎ擾s܂ŗLj
DWORD CEpgDataCap3Main::GetEpgInfo(
	WORD originalNetworkID,
	WORD transportStreamID,
	WORD serviceID,
	BOOL nextFlag,
	EPG_EVENT_INFO** epgInfo
	)
{
	if( Lock() == FALSE ) return ERR_FALSE;
	SYSTEMTIME nowTime;
	if( this->decodeUtilClass.GetNowTime(&nowTime) != NO_ERR ){
		GetLocalTime(&nowTime);
	}
	DWORD err = this->epgDBUtilClass.GetEpgInfo(originalNetworkID, transportStreamID, serviceID, nextFlag, nowTime, epgInfo);
	UnLock();
	return err;
}

//wCxgEPG擾
//߂lF
// G[R[h
//F
// originalNetworkID		[IN]擾ΏۂoriginalNetworkID
// transportStreamID		[IN]擾ΏۂtransportStreamID
// serviceID				[IN]擾ΏۂServiceID
// EventID					[IN]擾ΏۂEventID
// pfOnlyFlag				[IN]p/f̂݌邩ǂ
// epgInfo					[OUT]EPGiDLLŎIdeleteBɎ擾s܂ŗLj
DWORD CEpgDataCap3Main::SearchEpgInfo(
	WORD originalNetworkID,
	WORD transportStreamID,
	WORD serviceID,
	WORD eventID,
	BYTE pfOnlyFlag,
	EPG_EVENT_INFO** epgInfo
	)
{
	if( Lock() == FALSE ) return ERR_FALSE;

	DWORD err = this->epgDBUtilClass.SearchEpgInfo(originalNetworkID, transportStreamID, serviceID, eventID, pfOnlyFlag, epgInfo);
	UnLock();
	return err;
}

//EPGf[^̒~ϏԂZbg
void CEpgDataCap3Main::ClearSectionStatus()
{
	if( Lock() == FALSE ) return ;
	this->epgDBUtilClass.ClearSectionStatus();
	UnLock();
	return ;
}

//EPGf[^̒~ϏԂ擾
//߂lF
// Xe[^X
//F
// l_eitFlag		[IN]L-EIT̃Xe[^X擾
EPG_SECTION_STATUS CEpgDataCap3Main::GetSectionStatus(BOOL l_eitFlag)
{
	if( Lock() == FALSE ) return EpgNoData;
	EPG_SECTION_STATUS status = this->epgDBUtilClass.GetSectionStatus(l_eitFlag);
	UnLock();
	return status;
}

//PCvƂXg[ԂƂ̍擾
//߂lF
// ̕b
int CEpgDataCap3Main::GetTimeDelay(
	)
{
	if( Lock() == FALSE ) return 0;
	int delay = this->decodeUtilClass.GetTimeDelay();
	UnLock();
	return delay;
}
