#pragma once

#include "EpgDBManager.h"
#include "ReserveManager.h"
#include "SleepUtil.h"
#include "FileStreamingManager.h"
#include "NotifyManager.h"

#include "../../Common/ParseEpgAutoAddText.h"
#include "../../Common/ParseManualAutoAddText.h"
#include "../../Common/PipeServer.h"
#include "../../Common/TCPServer.h"
#include "../../Common/HttpServer.h"
#include "../../Common/TCPServerUtil.h"

#include "DLNAManager.h"

class CEpgTimerSrvMain
{
public:
	CEpgTimerSrvMain(void);
	~CEpgTimerSrvMain(void);

	//C[v
	//F
	// serviceFlag			[IN]T[rXƂĂ̋Nǂ
	void StartMain(
		BOOL serviceFlag
		);

	//C~
	void StopMain();

	//x~^X^oCڍsǂ
	//߂lF
	// TRUEiڍsjAFALSE
	BOOL IsSuspending();

	//x~^X^oCɈڍsč\Ȃ󋵂ǂ
	//߂lF
	// TRUEi\ȂjAFALSEiڍsĂ͑ʖځj
	BOOL ChkSuspend();

protected:
	HANDLE lockEvent;

	CEpgDBManager epgDB;
	CReserveManager reserveManager;
	CSleepUtil sleepUtil;
	CFileStreamingManager streamingManager;
	CNotifyManager notifyManager;

	CParseEpgAutoAddText epgAutoAdd;
	CParseManualAutoAddText manualAutoAdd;

	CPipeServer* pipeServer;
	CTCPServer* tcpServer;
	CHttpServer* httpServer;
	CTCPServerUtil* tcpSrvUtil;

	CDLNAManager* dlnaManager;

	HANDLE stopEvent;

	BOOL reloadEpgChkFlag;

	//map<DWORD,DWORD> registGUI; //PID,PID
	//map<wstring,REGIST_TCP_INFO> registTCP; //IP:Port

	BYTE suspendMode;
	BYTE rebootFlag;
	HANDLE sleepThread;
	BYTE suspendModeWork;
	BYTE rebootFlagWork;

	BOOL suspending;

	int wakeMargin;
	BOOL enableTCPSrv;
	DWORD tcpPort;
	int autoAddDays;
	int autoAddHour;
	BOOL chkGroupEvent;
	BYTE rebootDef;
	BOOL ngFileStreaming;
	BOOL ngEpgFileSrvCoop;
	BOOL enableHttpSrv;
	DWORD httpPort;
	BOOL enableDMS;

	BOOL enableHttpPublic;
	wstring httpPublicFolder;

	BOOL awayMode;

	vector<OLD_EVENT_INFO_DATA3> oldSearchList;
protected:
	//R}h֌Wrp
	BOOL Lock(LPCWSTR log = NULL, DWORD timeOut = 60*1000);
	void UnLock(LPCWSTR log = NULL);

	BOOL CheckTuijyu();

	BOOL AutoAddReserveEPG();
	BOOL AutoAddReserveProgram();

	void StartSleep(BYTE rebootFlag, BYTE suspendMode);
	void StartReboot();
	static UINT WINAPI SleepThread(void* param);
	BOOL QuerySleep(BYTE rebootFlag, BYTE suspendMode);
	BOOL QueryReboot(BYTE rebootFlag);

	void ReloadSetting();

	void AddRecFileDMS();

	//OR}h֌W
	static int CALLBACK CtrlCmdCallback(void* param, CMD_STREAM* cmdParam, CMD_STREAM* resParam);
	static int CALLBACK HttpCallback(void* param, HTTP_STREAM* recvParam, HTTP_STREAM* sendParam);
	static int CALLBACK TcpAcceptCallback(void* param, SOCKET clientSock, struct sockaddr_in* client, HANDLE stopEvent);


};

