#pragma once

#include "../../Common/Util.h"
#include "../../Common/EpgTimerUtil.h"
#include "../../Common/PathUtil.h"
#include "../../Common/StringUtil.h"
#include "../../Common/ParseChText4.h"

#include "TunerCtrl.h"
#include "TunerBankCtrl.h"

class CTunerManager
{
public:
	CTunerManager(void);
	~CTunerManager(void);

	//`[i[ꗗ̓ǂݍ݂s
	//߂lF
	// TRUEijAFALSEisj
	BOOL ReloadTuner();

	//`[i[IDꗗ擾B
	//߂lF
	// TRUEijAFALSEisj
	//F
	// idList			[OUT]`[i[IDꗗ
	BOOL GetEnumID(
		vector<DWORD>* idList
		);

	//`[i[\񐧌擾
	//߂lF
	// TRUEijAFALSEisj
	//F
	// ctrlMap			[OUT]`[i[\񐧌̈ꗗ
	BOOL GetEnumTunerBank(
		map<DWORD, CTunerBankCtrl*>* ctrlMap
		);

	//wT[rXT|[gĂȂ`[i[ꗗ擾
	//߂lF
	// TRUEijAFALSEisj
	//F
	// ONID				[IN]mFT[rXONID
	// TSID				[IN]mFT[rXTSID
	// SID				[IN]mFT[rXSID
	// idList			[OUT]`[i[IDꗗ
	BOOL GetNotSupportServiceTuner(
		WORD ONID,
		WORD TSID,
		WORD SID,
		vector<DWORD>* idList
		);

	BOOL GetSupportServiceTuner(
		WORD ONID,
		WORD TSID,
		WORD SID,
		vector<DWORD>* idList
		);

	BOOL GetCh(
		DWORD tunerID,
		WORD ONID,
		WORD TSID,
		WORD SID,
		DWORD* space,
		DWORD* ch
		);

	BOOL GetEnumEpgCapTuner(
		vector<DWORD>* idList
		);

	BOOL IsSupportService(
		DWORD tunerID,
		WORD ONID,
		WORD TSID,
		WORD SID
		);

	BOOL GetBonFileName(
		DWORD tunerID,
		wstring& bonFileName
		);

protected:
	typedef struct _TUNER_INFO{
		WORD bonID;
		WORD tunerID;
		wstring bonFileName;
		BOOL epgCapFlag;
		CParseChText4 chUtil;
		wstring chSet4FilePath;
	}TUNER_INFO;

	map<DWORD, TUNER_INFO*> tunerMap; //L[ bonID<<16 | tunerID
protected:
	BOOL FindBonFileName(wstring src, wstring& dllName);
};

