#include "stdafx.h"

#include "MPInclude.h"

#include "ThreadUtil.h"

typedef struct _MP_LOCK_HANDLE_ITEM{
#ifdef _WIN32
	HANDLE lockEvent;
#else
//Linuxn
	pthread_mutex_t	mutex;
#endif
}MP_LOCK_HANDLE_ITEM;

typedef struct _MP_THREAD_HANDLE_ITEM{
#ifdef _WIN32
	HANDLE thread;
#else
//Linuxn
	pthread_t thread;
#endif
}MP_THREAD_HANDLE_ITEM;


//rp̃nh쐬
//WindowsłCreateEvent
//Linuxnpthread_mutex_init
//߂lFnhAG[NULL
MP_LOCK_HANDLE MP_LOCK_CreateHandle(
	void
)
{
	MP_LOCK_HANDLE_ITEM* handle = NULL;
	handle = (MP_LOCK_HANDLE_ITEM*)malloc(sizeof(MP_LOCK_HANDLE_ITEM));
	if(handle != NULL ){
#ifdef _WIN32
		handle->lockEvent = CreateEvent(NULL, FALSE, TRUE, NULL);
#else
		pthread_mutex_init(&handle->mutex,NULL);
#endif
	}

	return (MP_LOCK_HANDLE)handle;
}

//nh̉
//handleNULL
//WindowsłCloseHandle
//Linuxnpthread_mutex_destroy
void MP_LOCK_CloseHandle(
	MP_LOCK_HANDLE* handle				//[IN]MP_LOCK_CreateHandle̖߂l
)
{
	MP_LOCK_HANDLE_ITEM* info = NULL;
	if( handle == NULL ){
		return;
	}
	info = (MP_LOCK_HANDLE_ITEM*)*handle;
	if( info != NULL ){
#ifdef _WIN32
		CloseHandle(info->lockEvent);
#else
		pthread_mutex_destroy(&info->mutex);
#endif
		free(info);
	}
	*handle = NULL;
}

//rpLock
//WindowsłWaitForSingleObject
//Linuxnpthread_mutex_lock
//߂lF0ȏŐA0ŃG[
int MP_LOCK_Lock(
	MP_LOCK_HANDLE handle				//[IN]MP_LOCK_CreateHandle̖߂l
)
{
	MP_LOCK_HANDLE_ITEM* info = NULL;
	if( handle == NULL ){
		return -1;
	}
	info = (MP_LOCK_HANDLE_ITEM*)handle;
#ifdef _WIN32
	WaitForSingleObject(info->lockEvent, INFINITE);
#else
	pthread_mutex_lock(&info->mutex);
#endif
	return 0;
}

//rpUnLock
//WindowsłSetEvent
//Linuxnpthread_mutex_unlock
//߂lF0ȏŐA0ŃG[
int MP_LOCK_UnLock(
	MP_LOCK_HANDLE handle				//[IN]MP_LOCK_CreateHandle̖߂l
)
{
	MP_LOCK_HANDLE_ITEM* info = NULL;
	if( handle == NULL ){
		return -1;
	}
	info = (MP_LOCK_HANDLE_ITEM*)handle;
#ifdef _WIN32
	SetEvent(info->lockEvent);
#else
	pthread_mutex_unlock(&info->mutex);
#endif
	return 0;
}

//ʃXbhŊ֐s
//Windowsł_beginthreadex
//Linuxnpthread_create
//߂lFnhAG[NULL
MP_THREAD_HANDLE MP_THREAD_BegineThread(
	MP_THREAD_FUNC func,				//[IN]VKXbh̎sN郋[`
	void* param							//[IN]VKXbhɓn
)
{
	MP_THREAD_HANDLE_ITEM* handle = NULL;
	if( func == NULL ){
		return NULL;
	}

	handle = (MP_THREAD_HANDLE_ITEM*)malloc(sizeof(MP_THREAD_HANDLE_ITEM));
	if( handle != NULL ){
#ifdef _WIN32
		handle->thread = (HANDLE)_beginthreadex(NULL, 0, func, param, CREATE_SUSPENDED, NULL);
		if( handle->thread != 0 ){
			ResumeThread(handle->thread);
		}else{
			free(handle);
			handle = NULL;
		}
#else
		//Linuxn
		if( pthread_create(&handle->thread, 0, func, param) != 0 ){
			free(handle);
			handle = NULL;
		}
#endif
	}

	return (MP_THREAD_HANDLE)handle;
}

//Xbh̏I҂Ji^CAEg͂Ȃj
//LZ͂炩ߍsĂ
//WindowsłWaitForSingleObject
//Linuxnpthread_join
//IhandleNULL
void MP_THREAD_WaitEndThread(
	MP_THREAD_HANDLE* handle			//[IN]MP_THREAD_BegineThread̖߂l
)
{
	MP_THREAD_HANDLE_ITEM* info = NULL;
	if( handle == NULL ){
		return ;
	}
	info = (MP_THREAD_HANDLE_ITEM*)*handle;
	if( info != NULL ){
#ifdef _WIN32
		WaitForSingleObject(info->thread, INFINITE);
#else
		pthread_join(info->thread);
#endif
		free(info);
	}
	*handle = NULL;
}

//Sleeps
//WindowsłSleep
//Linuxnnanosleep
void MP_Sleep(
	int msec			//[IN]msecP
)
{
#ifdef _WIN32
	Sleep(msec);
#else
	struct timespec req;
	req.tv_sec = msec/1000;
	req.tvnsec = (msec%1000)*1000*1000;
	nanosleep(&req, NULL);
#endif
}

