#ifndef __UPNP_SSDP_UTIL_H__
#define __UPNP_SSDP_UTIL_H__

#ifdef __cplusplus
extern "C" {
#endif

#include <stdlib.h>
#include "SortListUtil.h"
#include "UpnpStructDef.h"

typedef void* UPNP_SERVER_HANDLE;
typedef void* UPNP_MSEARCH_HANDLE;

typedef enum{
	SSDP_unknown        = 0x0000,
	SSDP_alive			= 0x0001,	//aliveʒm notifyParam͒ʒme(UPNP_SSDP_NOTIFY_INFO*)
	SSDP_byebye			= 0x0002,	//byebyeʒm notifyParam͒ʒme(UPNP_SSDP_NOTIFY_INFO*)
	SSDP_update			= 0x0004,	//updateʒm notifyParam͒ʒme(UPNP_SSDP_NOTIFY_INFO*)
	SSDP_MSearch		= 0x0010,	//M-Searcȟ notifyParam͒ʒme(UPNP_MSEARCH_RESPONSE_INFO*)
	SSDP_MSearchEnd		= 0x0020,	//M-Search̊ notifyParamUPNP_MSEARCH_HANDLE
} SSDP_NOTIFY_STATUS;


//SSDPNotifyʒmpR[obN֐
typedef void (*UPNP_SSDP_CALLBACK)(
	SSDP_NOTIFY_STATUS notifyType,		//[IN]ssdp̎
	void* notifyParam,					//[IN]NOTIFY̓e
	void* param							//[IN][U[w̃p[^
);

typedef int (*UPNP_MSEARCH_REQUEST_CALLBACK)(
	UPNP_MSEARCH_REQUEST_INFO* requestParam,	//[IN]NOTIFY̓e
	void* param,								//[IN][U[w̃p[^
	SORT_LIST_HANDLE resDeviceList				//[OUT]X|XƂĕԂfoCX̏@L[FUPNP_MSEARCH_RES_DEV_INFOuuid vfFUPNP_MSEARCH_RES_DEV_INFO*
);

//nh̍쐬
//߂lFnhAG[NULL
UPNP_SERVER_HANDLE UPNP_SERVER_CreateHandle(
	UPNP_SSDP_CALLBACK ssdpCallBack,	//[IN]SSDPNotifyʒmpR[obN
	void* ssdpCallBackParam,			//[IN]SSDPNotifyʒmpR[obNďoɓp[^[
	UPNP_MSEARCH_REQUEST_CALLBACK msearchCallBack,	//[IN]SSDPM-SEARCHNGXgʒmpR[obN
	void* msearchCallBackParam			//[IN]SSDPM-SEARCHNGXgʒmpR[obNďoɓp[^[
);

//nh̉
//handleNULL
void UPNP_SERVER_CloseHandle(
	UPNP_SERVER_HANDLE* handle			//[IN]UPNP_SERVER_CreateHandle̖߂l
);

//UPnPT[o[̋N
//߂lFG[R[h
int UPNP_SERVER_Start(
	UPNP_SERVER_HANDLE handle			//[IN]UPNP_SERVER_CreateHandle̖߂l
);

//UPnPT[o[̒~
//߂lFG[R[h
int UPNP_SERVER_Stop(
	UPNP_SERVER_HANDLE handle			//[IN]UPNP_SERVER_CreateHandle̖߂l
);

//Notifypdeviceserviceo^
int UPNP_SERVER_AddNotifyInfo(
	UPNP_SERVER_HANDLE handle,			//[IN]UPNP_SERVER_CreateHandle̖߂l
	const char* uuid,					//[IN]uuiduuuid:v͏Ȃ
	const char* urn,					//[IN]urnuurn:v܂
	int locationPort,					//[IN]Locatioñ|[g
	const char* locationUri				//[IN]Locatiońuhttp://ip:portv̕(u/vn܂)
);

//Notifypdeviceservice̓o^
int UPNP_SERVER_RemoveNotifyInfo(
	UPNP_SERVER_HANDLE handle,			//[IN]UPNP_SERVER_CreateHandle̖߂l
	const char* uuid					//[IN]uuiduuuid:v͏Ȃ
);

//NotifypdeviceservicȇSo^
int UPNP_SERVER_ClearNotifyInfo(
	UPNP_SERVER_HANDLE handle			//[IN]UPNP_SERVER_CreateHandle̖߂l
);

//M-Search @̌sij
//߂lFnhAG[NULL
UPNP_MSEARCH_HANDLE UPNP_MSearch_Exec(
	UPNP_SERVER_HANDLE handle,			//[IN]UPNP_SERVER_CreateHandle̖߂l
	const char* searchTarget,			//[IN]sST̒liL[j
	short mx,							//[IN]sMX̒l(PʁFb)i^CAEgj
	SORT_LIST_HANDLE* resultList		//[OUT]ʂ̃XgAL[Fchar* UUIDAvfFUPNP_MSEARCH_INFO*@UPNP_MSearch_CloseHandleŊJ邳
);

//M-Search @̌si񓯊j
//ʂ̓R[obNł̒ʒm̂
//߂lFnhAG[NULL
UPNP_MSEARCH_HANDLE UPNP_MSearch_ExecAsync(
	UPNP_SERVER_HANDLE handle,			//[IN]UPNP_SERVER_CreateHandle̖߂l
	const char* searchTarget,			//[IN]sST̒liL[j
	short mx							//[IN]sMX̒l(PʁFb)i^CAEgj
);

//M-Searchnh̉
//񓯊s͓̃LZ
//handleNULL
void UPNP_MSearch_CloseHandle(
	UPNP_MSEARCH_HANDLE* handle			//[IN]UPNP_MSearch_Exec or UPNP_MSearch_ExecAsync̖߂l
);

//DDD(Device Description Document)擾s()
//߂lF0ȏŐA0ŃG[
int UPNP_GetDDD_Exec(
	const char* location						//[IN]M-Searchʂlocation
);

#ifdef __cplusplus
}
#endif

#endif
