#include "StdAfx.h"
#include "WriteMain.h"

extern HINSTANCE g_instance;

CWriteMain::CWriteMain(void)
{
	this->file = NULL;
	this->writeBuff = NULL;
	this->writeBuffSize = 0;
	this->writeBuffPos = 0;

	WCHAR dllPath[512] = L"";
	GetModuleFileName(g_instance, dllPath, 512);

	wstring iniPath = dllPath;
	iniPath += L".ini";

	this->writeBuffSize = (DWORD)GetPrivateProfileIntW(L"SET", L"Size", 770048, iniPath.c_str());
	SAFE_DELETE_ARRAY(this->writeBuff);
	if( this->writeBuffSize > 0 ){
		this->writeBuff = new BYTE[this->writeBuffSize];
	}
	this->writeBuffPos = 0;
}


CWriteMain::~CWriteMain(void)
{
	if( this->file != NULL ){
		_StopSave();
	}

	SAFE_DELETE_ARRAY(this->writeBuff);
	this->writeBuffSize = 0;
	this->writeBuffPos = 0;
}

//t@CۑJn
//߂lF
// TRUEijAFALSEisj
//F
// fileName				[IN]ۑt@CtpXiKvɉĊgqςȂǍsj
// overWriteFlag		[IN]t@Cݎɏ㏑邩ǂiTRUEFAFALSEFȂj
// createSize			[IN]͗\zeʁi188oCgTSł̗eʁB^掞ȂǑԖ̏ꍇ0BȂǂ̉\̂Ŗڈxj
BOOL CWriteMain::_StartSave(
	LPCWSTR fileName,
	BOOL overWriteFlag,
	ULONGLONG createSize
	)
{
	this->savePath = L"";

	wstring errMsg = L"";
	DWORD err = 0;

	wstring recFilePath = fileName;
	if( overWriteFlag == TRUE ){
		_OutputDebugString(L"_StartSave CreateFile:%s", recFilePath.c_str());
		this->file = _CreateFile2( recFilePath.c_str(), GENERIC_WRITE, FILE_SHARE_READ, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
		if( this->file == INVALID_HANDLE_VALUE ){
			err = GetLastError();
			GetLastErrMsg(err, errMsg);
			_OutputDebugString(L"_StartSave Err:0x%08X %s", err, errMsg.c_str());
			if( GetNextFileName(fileName, recFilePath) == TRUE ){
				_OutputDebugString(L"_StartSave CreateFile:%s", recFilePath.c_str());
				this->file = _CreateFile2( recFilePath.c_str(), GENERIC_WRITE, FILE_SHARE_READ, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
			}
		}
	}else{
		_OutputDebugString(L"_StartSave CreateFile:%s", recFilePath.c_str());
		this->file = _CreateFile2( recFilePath.c_str(), GENERIC_WRITE, FILE_SHARE_READ, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL );
		if( this->file == INVALID_HANDLE_VALUE ){
			err = GetLastError();
			GetLastErrMsg(err, errMsg);
			_OutputDebugString(L"_StartSave Err:0x%08X %s", err, errMsg.c_str());
			if( GetNextFileName(fileName, recFilePath) == TRUE ){
				_OutputDebugString(L"_StartSave CreateFile:%s", recFilePath.c_str());
				this->file = _CreateFile2( recFilePath.c_str(), GENERIC_WRITE, FILE_SHARE_READ, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL );
			}
		}
	}
	if( this->file == INVALID_HANDLE_VALUE ){
		err = GetLastError();
		GetLastErrMsg(err, errMsg);
		_OutputDebugString(L"_StartSave Err:0x%08X %s", err, errMsg.c_str());
		this->file = NULL;
		return FALSE;
	}

	//fBXNɗeʂm
	if( createSize > 0 ){
		LARGE_INTEGER stPos;
		stPos.QuadPart = createSize;
		SetFilePointerEx( this->file, stPos, NULL, FILE_BEGIN );
		SetEndOfFile( this->file );
		CloseHandle( this->file );
		this->file = _CreateFile2( recFilePath.c_str(), GENERIC_WRITE, FILE_SHARE_READ, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
		SetFilePointer( this->file, 0, NULL, FILE_BEGIN );
	}

	this->savePath = recFilePath;

	return TRUE;
}

//t@CۑI
//߂lF
// TRUEijAFALSEisj
BOOL CWriteMain::_StopSave(
	)
{
	if( this->file != NULL ){
		if( this->writeBuffPos > 0 ){
			DWORD writeSize = 0;
			DWORD err = 0;
			wstring errMsg = L"";
			if( WriteFile(this->file, this->writeBuff, this->writeBuffPos, &writeSize, NULL) == FALSE ){
				err = GetLastError();
				GetLastErrMsg(err, errMsg);
				_OutputDebugString(L"_StopSave WriteFile Err:0x%08X %s", err, errMsg.c_str());
			}else{
				this->writeBuffPos = 0;
			}
		}
		SetEndOfFile(this->file);
		CloseHandle(this->file);
		this->file = NULL;
	}

	return TRUE;
}

//ۂɕۑĂt@CpX擾iĐob`ɗpj
//filePathNULL͕KvȃTCYfilePathSizeŕԂ
//ʏfilePathSize=512ŌĂяo
//߂lF
// TRUEijAFALSEisj
//F
// filePath				[OUT]ۑt@CtpX
// filePathSize			[IN/OUT]filePath̃TCY(WCHARP)
BOOL CWriteMain::_GetSaveFilePath(
	WCHAR* filePath,
	DWORD* filePathSize
	)
{
	if( filePath == NULL ){
		if( filePathSize == NULL ){
			return FALSE;
		}else{
			*filePathSize = (DWORD)this->savePath.size()+1;
		}
	}else{
		if( filePathSize == NULL ){
			return FALSE;
		}else{
			if( *filePathSize < (DWORD)this->savePath.size()+1 ){
				*filePathSize = (DWORD)this->savePath.size()+1;
				return FALSE;
			}else{
				wcscpy_s(filePath, *filePathSize, this->savePath.c_str());
			}
		}
	}
	return TRUE;
}

//ۑpTSf[^𑗂
//󂫗eʕsȂǂŏosꍇAwriteSize̒l
//ēxۑƂ̑MJnn_߂
//߂lF
// TRUEijAFALSEisj
//F
// data					[IN]TSf[^
// size					[IN]datãTCY
// writeSize			[OUT]ۑɗpTCY
BOOL CWriteMain::_AddTSBuff(
	BYTE* data,
	DWORD size,
	DWORD* writeSize
	)
{
	BOOL ret = FALSE;
	wstring errMsg = L"";
	DWORD err = 0;
	if( this->file != NULL && data != NULL && size > 0 ){
		if( this->writeBuffSize > 0 && this->writeBuff != NULL){
			if( size > this->writeBuffSize ){
				//obt@TCY傫̂ł̂܂܏o
				if( this->writeBuffPos > 0 ){
					//Õobt@̂Őɏo
					DWORD write = 0;
					wstring errMsg = L"";
					if( WriteFile(this->file, this->writeBuff, this->writeBuffPos, &write, NULL) == FALSE ){
						//G[o
						err = GetLastError();
						GetLastErrMsg(err, errMsg);
						_OutputDebugString(L"_StopSave WriteFile Err:0x%08X %s", err, errMsg.c_str());
						*writeSize = 0;
						//߂Ȃobt@̐擪փRs[
						DWORD tempBuffSize = this->writeBuffPos-write;
						if( tempBuffSize > 0 ){
							BYTE* tempBuff = new BYTE[tempBuffSize];
							memcpy( tempBuff, this->writeBuff+write, tempBuffSize);
							this->writeBuffPos = tempBuffSize;
							memcpy(this->writeBuff, tempBuff, tempBuffSize);
							SAFE_DELETE_ARRAY(tempBuff);
						}

						SetEndOfFile(this->file);
						CloseHandle(this->file);
						this->file = NULL;

						return FALSE;
					}else{
						this->writeBuffPos = 0;
					}
				}
				//t@Co
				if( WriteFile(this->file, data, size, writeSize, NULL) == FALSE ){
					//G[o
					err = GetLastError();
					GetLastErrMsg(err, errMsg);
					_OutputDebugString(L"WriteFile Err:0x%08X %s", err, errMsg.c_str());

					SetEndOfFile(this->file);
					CloseHandle(this->file);
					this->file = NULL;

					return FALSE;
				}else{
					ret = TRUE;
				}
			}else{
				if(this->writeBuffSize < this->writeBuffPos + size){
					//obt@܂̂ŏo
					DWORD tempSize = this->writeBuffSize - this->writeBuffPos;
					memcpy( this->writeBuff+this->writeBuffPos, data, tempSize );
					DWORD tempWriteSize = 0;
					if( WriteFile(this->file, this->writeBuff, this->writeBuffSize, &tempWriteSize, NULL) == FALSE ){
						//G[
						err = GetLastError();
						GetLastErrMsg(err, errMsg);
						_OutputDebugString(L"_StopSave WriteFile Err:0x%08X %s", err, errMsg.c_str());
						*writeSize = 0;
						//t@C|C^߂
						LONG lpos = (LONG)tempWriteSize;
						SetFilePointer(this->file, -lpos, NULL, FILE_CURRENT);

						SetEndOfFile(this->file);
						CloseHandle(this->file);
						this->file = NULL;

						return FALSE;
					}else{
						//obt@ɃRs[
						memcpy( this->writeBuff, data+tempSize, size-tempSize );
						this->writeBuffPos = size-tempSize;
						*writeSize = size;
						ret = TRUE;
					}
				}else{
					//obt@ɃRs[
					memcpy( this->writeBuff+this->writeBuffPos, data, size );
					this->writeBuffPos += size;
					*writeSize = size;
					ret = TRUE;
				}
			}
		}else{
			ret = WriteFile(this->file, data, size, writeSize, NULL);
			if( ret == FALSE ){
				err = GetLastError();
				GetLastErrMsg(err, errMsg);
				_OutputDebugString(L"WriteFile Err:0x%08X %s", err, errMsg.c_str());

				SetEndOfFile(this->file);
				CloseHandle(this->file);
				this->file = NULL;
			}
		}
	}
	return ret;
}

BOOL CWriteMain::GetNextFileName(wstring filePath, wstring& newPath)
{
	WCHAR szPath[_MAX_PATH];
	WCHAR szDrive[_MAX_DRIVE];
	WCHAR szDir[_MAX_DIR];
	WCHAR szFname[_MAX_FNAME];
	WCHAR szExt[_MAX_EXT];
	_wsplitpath_s( filePath.c_str(), szDrive, _MAX_DRIVE, szDir, _MAX_DIR, szFname, _MAX_FNAME, szExt, _MAX_EXT );
	_wmakepath_s(  szPath, _MAX_PATH, szDrive, szDir, NULL, NULL );

	BOOL findFlag = FALSE;
	for( int i=1; i<1000; i++ ){
		WIN32_FIND_DATA findData;
		HANDLE find;

		wstring name;
		Format(name, L"%s%s-(%d)%s", szPath, szFname, i, szExt);
		newPath = name;
		
		find = FindFirstFile( newPath.c_str(), &findData);
		if ( find == INVALID_HANDLE_VALUE ) {
			findFlag = TRUE;
			break;
		}
		FindClose(find);
	}
	return findFlag;
}
