#include "StdAfx.h"
#include "TwitterMain.h"
#include "RequestUtil.h"
#include <process.h>

extern HINSTANCE g_Instance;

CTwitterMain::CTwitterMain(void)
{
	this->lockEvent = _CreateEvent(FALSE, TRUE, NULL);
	this->authorizationUrl = NULL;
	this->useProxy = FALSE;
	this->chgProxy = TRUE;

    this->tweetThread = NULL;
    this->tweetStopEvent = _CreateEvent(FALSE, FALSE, NULL);
	this->tweetSetEvent = _CreateEvent(FALSE, FALSE, NULL);

	WCHAR filePath[512] = L"";
	GetModuleFileName(g_Instance, filePath, 512);
	this->moduleIniPath = filePath;
	this->moduleIniPath += L".ini";

	this->sendWaitSec = 5;
}


CTwitterMain::~CTwitterMain(void)
{
	if( this->tweetThread != NULL ){
		::SetEvent(this->tweetStopEvent);
		// XbhI҂
		if ( ::WaitForSingleObject(this->tweetThread, 15000) == WAIT_TIMEOUT ){
			::TerminateThread(this->tweetThread, 0xffffffff);
		}
		CloseHandle(this->tweetThread);
		this->tweetThread = NULL;
	}
	if( this->tweetStopEvent != NULL ){
		CloseHandle(this->tweetStopEvent);
		this->tweetStopEvent = NULL;
	}
	if( this->tweetSetEvent != NULL ){
		CloseHandle(this->tweetSetEvent);
		this->tweetSetEvent = NULL;
	}

	SAFE_DELETE_ARRAY(this->authorizationUrl);
	this->httpUtil.CloseSession();
	if( this->lockEvent != NULL ){
		UnLock();
		CloseHandle(this->lockEvent);
		this->lockEvent = NULL;
	}
}

BOOL CTwitterMain::Lock(LPCWSTR log, DWORD timeOut)
{
	if( this->lockEvent == NULL ){
		return FALSE;
	}
	if( log != NULL ){
		OutputDebugString(log);
	}
	DWORD dwRet = WaitForSingleObject(this->lockEvent, timeOut);
	if( dwRet == WAIT_ABANDONED || 
		dwRet == WAIT_FAILED ||
		dwRet == WAIT_TIMEOUT){
			OutputDebugString(L"CTwitterMain::Lock FALSE");
		return FALSE;
	}
	return TRUE;
}

void CTwitterMain::UnLock(LPCWSTR log)
{
	if( this->lockEvent != NULL ){
		SetEvent(this->lockEvent);
	}
	if( log != NULL ){
		OutputDebugString(log);
	}
}

//DLL̏
//߂lF
// G[R[h
DWORD CTwitterMain::Initialize(
	)
{
	WCHAR buff[512] = L"";
	GetPrivateProfileString(L"SET", L"token", L"", buff, 512, this->moduleIniPath.c_str());
	this->oauth_token = buff;
	ZeroMemory(buff, sizeof(WCHAR)*512);
	GetPrivateProfileString(L"SET", L"token_secret", L"", buff, 512, this->moduleIniPath.c_str());
	this->oauth_token_secret = buff;

	this->sendWaitSec = GetPrivateProfileInt(L"SET", L"SendWaitSec", 1, this->moduleIniPath.c_str());
	
	return NO_ERR;
}

//DLL̊J
//߂lF
// G[R[h
DWORD CTwitterMain::UnInitialize(
	)
{
	if( this->tweetThread != NULL ){
		::SetEvent(this->tweetStopEvent);
		// XbhI҂
		if ( ::WaitForSingleObject(this->tweetThread, 15000) == WAIT_TIMEOUT ){
			::TerminateThread(this->tweetThread, 0xffffffff);
		}
		CloseHandle(this->tweetThread);
		this->tweetThread = NULL;
	}
	this->httpUtil.CloseSession();

	this->tweetQue.clear();
	return NO_ERR;
}

//IEProxyݒ擾
//߂lF
// TRUEi֐jAFALSEi֐sj
//F
// proxyConfig		[OUT]IEProxyݒ̏iAPIďo܂Ńmہj
BOOL CTwitterMain::GetIEProxyConfig(
	CURRENT_USER_IE_PROXY_CONFIG** proxyConfig
	)
{
	return this->proxyUtil.GetIEProxyConfig(proxyConfig);
}

//IɌoProxỹAhX擾
//߂lF
// TRUEi֐jAFALSEi֐sj
//F
// proxyConfig		[OUT]Proxy̏iAPIďo܂Ńmہj
BOOL CTwitterMain::GetProxyAutoDetect(
	PROXY_CONFIG** proxyConfig
	)
{
	return this->proxyUtil.GetProxyAutoDetect(PROXY_CHK_URL, proxyConfig);
}

//\XNvgProxỹAhX擾
//߂lF
// TRUEi֐jAFALSEi֐sj
//F
// scriptURL		[IN]\XNvgURL
// proxyConfig		[OUT]Proxy̏iAPIďo܂Ńmہj
BOOL CTwitterMain::GetProxyAutoScript(
	LPCWSTR scriptURL, //[IN]\XNvgURL
	PROXY_CONFIG** proxyConfig //[OUT]Proxy̏
	)
{
	return this->proxyUtil.GetProxyAutoScript(PROXY_CHK_URL, scriptURL, proxyConfig);
}

//Proxygpݒ
//߂lF
// G[R[h
//F
// useProxy			[IN]ProxygǂiTRUE:Proxygj
// proxyInfo		[IN]Proxygꍇ̐ݒ
void CTwitterMain::SetProxy(
	BOOL useProxy,
	USE_PROXY_INFO* proxyInfo
	)
{
	this->useProxy = useProxy;
	this->proxyInfo = *proxyInfo;
	this->chgProxy = TRUE;
}

//FؗpOCURL擾
//߂lF
// G[R[h
//F
// url			[OUT]FؗpOCURLiAPIďo܂Ńmہj
DWORD CTwitterMain::GetAuthorizationUrl(
	WCHAR** url
	)
{
	if( Lock() == FALSE ) return ERR_FALSE;
	SAFE_DELETE_ARRAY(this->authorizationUrl);
	DWORD ret = NO_ERR;

	CRequestUtil requestUtil;

	wstring requestUrl;
	wstring httpHeader;

	CRequestUtil request;
	wstring key = CONSUMER_SECRET_KEY;
	key += L"&";
	requestUtil.CreateRequestToken(CONSUMER_KEY, key, requestUrl, httpHeader);

	ret = SendCmd(FALSE, NW_VERB_POST, requestUrl.c_str(), httpHeader.c_str(), NULL, L"");
	if( ret == NO_ERR ){
		//X|X擾ĉ
		wstring buff = this->lastResponse;
		Replace(buff, L"oauth_token=", L"");
		Separate(buff, L"&oauth_token_secret=", this->authorization_token, this->authorization_token_secret);

		wstring authUrl;
		request.CreateAuthorizationUrl(this->authorization_token.c_str(), authUrl);
		authorizationUrl = new WCHAR[authUrl.size() + 1];
		wcscpy_s(authorizationUrl, authUrl.size() + 1, authUrl.c_str());
		*url = authorizationUrl;
	}

	UnLock();
	return ret;
}

//F،ʂ̈Ïؔԍݒ肷
//GetAuthorizationUrlŎ擾lgp̂ŁAA̗Őݒ肷Kv
//߂lF
// G[R[h
//F
// password		[IN]Ïؔԍ
DWORD CTwitterMain::SetAuthorizationPWD(
	LPCWSTR password
	)
{
	if( Lock() == FALSE ) return ERR_FALSE;
	DWORD ret = NO_ERR;
	CRequestUtil requestUtil;

	wstring requestUrl;
	wstring httpHeader;

	wstring key = CONSUMER_SECRET_KEY;
	key += L"&";
	key += this->authorization_token_secret.c_str();

	requestUtil.CreateAccessToken(CONSUMER_KEY, key, this->authorization_token.c_str(), password, requestUrl, httpHeader);
	ret = SendCmd(FALSE, NW_VERB_POST, requestUrl.c_str(), httpHeader.c_str(), NULL, L"");
	if( ret == NO_ERR ){
		//X|X擾ĉ
		wstring buff = this->lastResponse;
		Replace(buff, L"oauth_token=", L"");
		Separate(buff, L"&oauth_token_secret=", this->oauth_token, buff);
		Separate(buff, L"&", this->oauth_token_secret, buff);

		WritePrivateProfileString(L"SET", L"token", this->oauth_token.c_str(), this->moduleIniPath.c_str() );
		WritePrivateProfileString(L"SET", L"token_secret", this->oauth_token_secret.c_str(), this->moduleIniPath.c_str() );
	}

	UnLock();
	return ret;
}

//cC[g
//߂lF
// G[R[h
//F
// asyncMode	[IN]񓯊őM
// text			[IN]cC[ge
DWORD CTwitterMain::SendTweet(
	BOOL asyncMode,
	LPCWSTR text
	)
{
	if( Lock() == FALSE ) return ERR_FALSE;

	DWORD ret = NO_ERR;
	if( this->oauth_token.size() > 0 && this->oauth_token_secret.size() > 0 ){
		wstring buff = text;
		if( buff.size() > 140 ){
			buff = buff.substr(0,139);
			buff+=L"c";
		}
		if( asyncMode == TRUE ){
			this->tweetQue.push_back(buff);

			SetEvent(this->tweetSetEvent);
			if( this->tweetThread == NULL ){
				ResetEvent(this->tweetStopEvent);
				this->tweetThread = (HANDLE)_beginthreadex(NULL, 0, TweetThread, (LPVOID)this, CREATE_SUSPENDED, NULL);
				SetThreadPriority( this->tweetThread, THREAD_PRIORITY_NORMAL );
				ResumeThread(this->tweetThread);
			}
		}else{
			CRequestUtil requestUtil;

			wstring requestUrl;
			wstring httpHeader;

			wstring key = CONSUMER_SECRET_KEY;
			key += L"&";
			key += this->oauth_token_secret.c_str();
			requestUtil.CreateSendTweet(CONSUMER_KEY, key, this->oauth_token.c_str(), buff.c_str(), requestUrl, httpHeader);
			if(SendCmd(FALSE, NW_VERB_POST, requestUrl.c_str(), httpHeader.c_str(), NULL, L"") != NO_ERR ){
				_OutputDebugString(L"tweet send Err:%s", this->lastResponse.c_str());
				_OutputDebugString(buff.c_str());
				ret = ERR_FALSE;
			}
		}
	}else{
		ret = ERR_INIT;
	}

	UnLock();
	return ret;
}

UINT WINAPI CTwitterMain::TweetThread(LPVOID param)
{
	CTwitterMain* sys = (CTwitterMain*)param;
	HANDLE eventArray[2];
	eventArray[0] = sys->tweetStopEvent;
	eventArray[1] = sys->tweetSetEvent;

	DWORD nextWait = sys->sendWaitSec * 1000;
	while(1){
		DWORD res = WaitForMultipleObjects(2, eventArray, FALSE, INFINITE);
		if( res == WAIT_OBJECT_0 ){
			//LZꂽ
			break;
		}else if( res == WAIT_OBJECT_0+1 ){
			while(1){
				BOOL end = FALSE;
				wstring text = L"";
				if( sys->Lock() == TRUE ){
					if( sys->tweetQue.size() > 0 ){
						text = sys->tweetQue[0];
						sys->tweetQue.erase(sys->tweetQue.begin());
					}else{
						end = TRUE;
					}
					sys->UnLock();
				}
				if( text.size() > 0 ){
					if( sys->oauth_token.size() > 0 && sys->oauth_token_secret.size() > 0 ){
						CRequestUtil requestUtil;

						wstring requestUrl;
						wstring httpHeader;

						wstring key = CONSUMER_SECRET_KEY;
						key += L"&";
						key += sys->oauth_token_secret.c_str();
						requestUtil.CreateSendTweet(CONSUMER_KEY, key, sys->oauth_token.c_str(), text, requestUrl, httpHeader);
						if(sys->SendCmd(FALSE, NW_VERB_POST, requestUrl.c_str(), httpHeader.c_str(), NULL, L"") != NO_ERR ){
							_OutputDebugString(L"tweet send Err:%s", sys->lastResponse.c_str());
						}
					}
				}
				if(end == TRUE ){
					break;
				}
				if( WaitForSingleObject(sys->tweetStopEvent, nextWait) == WAIT_OBJECT_0 ){
					//LZꂽ
					return 0;
				}
			}
		}
	}
	return 0;
}

DWORD CTwitterMain::SendCmd(BOOL asyncMode, NW_VERB_MODE verbMode, wstring url, wstring httpHead, UPLOAD_DATA_LIST* upList, wstring saveFilePath)
{
	DWORD ret = NO_ERR;

	if( asyncMode != this->httpUtil.IsOpenASync() ){
		this->httpUtil.CloseSession();
	}else
	if( this->chgProxy == TRUE ){
		this->httpUtil.CloseSession();
		this->chgProxy = FALSE;
	}
	if( this->httpUtil.IsOpenSession() == FALSE ){
		ret = this->httpUtil.OpenSession(L"", asyncMode, this->useProxy, &this->proxyInfo);
		if( ret != NO_ERR ){
			this->httpUtil.CloseSession();
			return ret;
		}
	}

	ret = this->httpUtil.SendRequest(url.c_str(), verbMode, httpHead.c_str(), saveFilePath.c_str(), upList);
	//G[`FbN
	if( ret == 0x8197 ){
		ret = ERR_NW_PROXY_LOGIN;
	}

	//ڑ̏ꍇAX|XŃoɎ擾Ă
	if( asyncMode == FALSE ){
		this->lastResponse = L"";

		DWORD dlSize = 0;
		this->httpUtil.GetDLBuff(NULL,&dlSize);
		if( dlSize > 0 ){
			BYTE* responseBuff = new BYTE[dlSize+1];
			ZeroMemory(responseBuff, dlSize+1);
			this->httpUtil.GetDLBuff(responseBuff,&dlSize);

			UTF8toW((char*)responseBuff, this->lastResponse);

			delete[] responseBuff;
		}
	}

	return ret;
}

//񓯊cC[g̎c擾
//߂lF
// 
DWORD CTwitterMain::GetTweetQue(
	)
{
	if( Lock() == FALSE ) return 0;

	DWORD ret = (DWORD)this->tweetQue.size();

	UnLock();
	return ret;
}